"use strict";

jQuery( document ).ready( function($) {

	  function reloadPageContent() {
			jQuery.ajax({
				url: window.location.href,
				cache: false,
				success: function (response) {
					jQuery('#content').html(response);
					jQuery('#main-content').html(response);
	                hideDuplicateElements('.af_tbw_tipping_donation_div');
					hideDuplicateElements('.site-header');
					hideDuplicateElements('.storefront-breadcrumb');
					hideDuplicateElements('.site-footer');

				},
				error: function (xhr, status, error) {
					console.error(status, error);
				}
			});
		}
		function hideDuplicateElements(selector) {
			var elements = jQuery(selector);
			if (elements.length > 1) {
				elements.last().hide();
			}
		}


		let contentReloaded = false;
		let timeoutId;

		wp.hooks.addAction('experimental__woocommerce_blocks-cart-set-item-quantity', 'a-cm-cart-block', function(item) {
		    if (!contentReloaded) {
		        clearTimeout(timeoutId);
		        timeoutId = setTimeout(() => {
		            $('.af_tbw_tipping_donation_div').empty();
		            reloadPageContent();
		            contentReloaded = true;
		        }, 2000);
		    }
		});

	var af_cart_block_content = afwtd_cart_data.cart_block_content;
	var message_position_cart = afwtd_cart_data.message_position_cart;
	var af_checkout_block_content = afwtd_checkout_data.checkout_block_content;
	var message_position_checkout = afwtd_checkout_data.message_position_checkout;
	// cart block.
	setTimeout(function(){

		if (message_position_cart === 'woocommerce_before_cart') {
			$(af_cart_block_content).insertBefore('.wp-block-woocommerce-cart-line-items-block');
	    } else if (message_position_cart === 'woocommerce_before_cart_collaterals') {
	       $(af_cart_block_content).insertAfter('.wp-block-woocommerce-cart-line-items-block');
	    } else if (message_position_cart === 'woocommerce_after_cart') {
	        $(af_cart_block_content).insertAfter('.wp-block-woocommerce-proceed-to-checkout-block');
	    } else {
	        $(af_cart_block_content).insertBefore('.wp-block-woocommerce-cart-line-items-block');
	    }
	}, 2000);

	// chekout block.
	setTimeout(function(){
		if (message_position_checkout === 'woocommerce_checkout_before_customer_details') {
			$(af_checkout_block_content).insertBefore('.wp-block-woocommerce-checkout-contact-information-block');
	    } else if (message_position_checkout === 'woocommerce_before_checkout_billing_form') {
	       $(af_checkout_block_content).insertBefore('.wc-block-checkout__use-address-for-billing');
	    } else if (message_position_checkout === 'woocommerce_after_checkout_billing_form') {
	        $(af_checkout_block_content).insertBefore('.wp-block-woocommerce-checkout-shipping-methods-block');
	    } else if (message_position_checkout === 'woocommerce_before_order_notes') {
	       $(af_checkout_block_content).insertBefore('.wp-block-woocommerce-checkout-order-note-block');
	    } else if (message_position_checkout === 'woocommerce_after_order_notes') {
	        $(af_checkout_block_content).insertAfter('.wp-block-woocommerce-checkout-order-note-block');
	    } else if (message_position_checkout === 'woocommerce_after_checkout_form') {
	        $(af_checkout_block_content).insertAfter('.wp-block-woocommerce-checkout-actions-block');
	    } else {
	        $(af_checkout_block_content).insertBefore('.wp-block-woocommerce-checkout-contact-information-block');
	    }
	}, 2000);
	setTimeout(function(){
   function appendRemoveLink() {
        var donationTitle = afwtd_cart_data.message_total_remove;
        var message_template = afwtd_cart_data.message_template;
        $('.wc-block-components-totals-fees').each(function() {
            const feeRow = $(this);
            const feeLabel = feeRow.find('.wc-block-components-totals-item__label').text().trim();

            if (feeLabel.includes(donationTitle)) {
                if (!feeRow.find('.af_tbw_removedata').length) {
                	var removeLink;
                	if(message_template == 'popup'){
                        removeLink = $('<a href="javascript:void(0)" class="af_tbw_change_donation">Change</a>');
                    }else{
                       removeLink = $('<a href="javascript:void(0)" class="af_tbw_removedata adf-remove-btn">Remove</a>');
                    }
                    feeRow.find('.wc-block-components-totals-item__value').append(removeLink);
                }
            }
        });
    }
    appendRemoveLink();
	   $('.af_tbw_select_fixed').select2();
		$('.af_tbw_Select_percentage').select2();

		if ($( '.af_tbw_Select_percentage' ).val() == 'others') {
				$( '.af_tbw_other_options' ).show();
				$( '.af_tbw_select_percentage' ).hide();
	    } else {
			$('.af_tbw_other_options').hide();
			$('.af_tbw_select_percentage').show();
	    }
	    if ($('.af_tbw_select_fixed').val() == 'others') {
			$( '.af_tbw_other_options_fixed' ).show();
			$( '.af_tbw_select_fixed_btn' ).hide();
	    } else {
			$( '.af_tbw_other_options_fixed' ).hide();
			$( '.af_tbw_select_fixed_btn' ).show();
	    }
	    if( $('.other').is(':checked') ){
			$( '.af_tbw_radio_button' ).prop( 'checked',false );
			$( '.af_tbw_other_options' ).show();
		}
		if( $('.fixed-other').is(':checked') ){
			$( '.af_tbw_radio_button_fixed' ).prop( 'checked',false );
			$( '.af_tbw_other_options_fixed' ).show();

		}
		$('.adf-main-popup .af-close-popup').on('click', function(){
			$(this).closest('.adf-main-popup').hide();
			var cookieExpirationHours = 24;
			Cookies.set('adf_popup_closed', 'true', { expires: cookieExpirationHours / 24 });
		});
		if (Cookies.get('adf_popup_closed')) {
	       $('.adf-main-popup').hide();
	    }
	    if (Cookies.get('popup_closed')) {
	       $('.adf-main-popup').hide();
	    }
	    $('.adf-popup-pre-defined-value input[name="af_tbw_button_percentage_popup"]').on('change', function() {
		    $('.adf-popup-pre-defined-value .adf-popup-options').removeClass('active');
		    $('.af_tbw_other_percentage').val('');
		    $(this).closest('.adf-popup-options').addClass('active');
		});
		$('.af_tbw_other_percentage').on('keyup', function(){
			$('.adf-popup-pre-defined-value .adf-popup-options').removeClass('active');
		});
		$('.adf-popup-pre-defined-value input[name="af_tbw_button_fixed_popup"]').on('change', function() {
		    $('.adf-popup-pre-defined-value .adf-popup-options').removeClass('active');
		    $('.af_tbw_fixed_amount').val('');
		    $(this).closest('.adf-popup-options').addClass('active');
		});
		$('.af_tbw_fixed_amount').on('keyup', function(){
			$('.adf-popup-pre-defined-value .adf-popup-options').removeClass('active');
		});
		jQuery( ".af_tbw_fixed_amount, .af_tbw_other_percentage" ).on(
			"keypress",
			function (event) {

				if (event.which < 48 || event.which > 57) {

					event.preventDefault();

				}

			}
		);
		$('.af_tbw_radio_button').prop('checked',false);
$('.af_tbw_radio_button_fixed').prop('checked',false);
	}, 2000);
});