<?php
/**
 * File containing the Af_Dontation_Checkout_Block class.
 *
 * @package addify-tipping-at-cart-checkout
 */

if ( ! defined( 'ABSPATH' ) ) {
	die;
}
/**
 * Checkout block compatibility.
 */
if (!class_exists('Af_Dontation_Checkout_Block') ) {
	class Af_Dontation_Checkout_Block {

		public function __construct() {
			add_action( 'wp_enqueue_scripts', array( $this, 'afwtd_checkout_block_file_enque' ) );
			add_action( 'woocommerce_thankyou', array( $this, 'af_tbw_save_tipping_donation_in_reports_table' ), 10, 1 );
		}
		public function afwtd_checkout_block_file_enque() {
			wp_enqueue_script( 'front-block-script', AF_T_B_W_PLUGIN_URL . '/assets/js/afwtd-block-script.js', array( 'jquery' ), '1.1.0', false );

			if ( WC()->cart && WC()->cart->is_empty() ) {

				return;
			}
			$current_user_role   = is_user_logged_in() ? wp_get_current_user()->roles : array( 'guest' );
			$af_tipping_userrole = get_option('af_tipping_or_donation_userrole');
			if ( ! empty( $af_tipping_userrole ) && !empty($current_user_role) ) {
				$count_match_roles = array_intersect( (array) $af_tipping_userrole, $current_user_role );
				if (empty($count_match_roles)) {
					return;
				}
			}
			$af_td_other_field_place_holder                = get_option('af_td_other_field_place_holder');
			$af_tbw_tipping_or_donation_precentage_options = get_option( 'af_tbw_tipping_or_donation_precentage_options' );
			

			$af_tbw_tipping_detail = (array) WC()->session->get( 'af_tbw_tipping_detail' );

			$type         = isset( $af_tbw_tipping_detail['type'] ) ? $af_tbw_tipping_detail['type'] : '';
			$custom_value = isset( $af_tbw_tipping_detail['custom_value'] ) ? $af_tbw_tipping_detail['custom_value'] : '';

			$af_tbw_restriction_found = false;
			$af_tbw_restriction_found = $this->af_tbw_check_restrictions();

			if ( ( ( empty( (array) get_option( 'af_tbw_products_tipping_or_donation_restriction_product_ids' ) ) ) &&
				( empty( (array) get_option( 'af_tbw_categories_tipping_donation_restriction_category_ids' ) ) ) &&
				( empty( (array) get_option( 'af_tbw_shipping_tipping_or_donation_restriction_shipping_method_ids' ) ) ) ) ||
				( true == ( $af_tbw_restriction_found ) ) ) {
				$adf_checkout_block                            ='<div id="af_tbw_tipping_donation_div" class="af_tbw_tipping_donation_div_get ' . $af_tbw_tipping_or_donation_precentage_options . '">';
				$af_tbw_tipping_or_donation_type               = get_option( 'af_tbw_tipping_or_donation_type', 'fixed' );
				$af_tbw_tipping_or_donation_precentage_options = get_option( 'af_tbw_tipping_or_donation_precentage_options' );
				$af_tbw_tipping_or_donation_button_text        = get_option( 'af_tbw_tipping_or_donation_button_text', 'Tip/donate' );
				$af_tbw_percentage_predefiend_values           = get_option( 'af_tbw_percentage_predefiend_values', '5,10,15' );
				$af_tbw_tipping_or_donation_message_text       = get_option( 'af_tbw_tipping_or_donation_message_text', 'tip/donate ?' );
				$af_tbw_fixed_placeholder                      = get_option( 'af_tbw_fixed_placeholder' );
				$af_td_other_btn_text                          = get_option( 'af_td_other_btn_text' );
				$af_tbw_tipping_or_donation_heading_text       = get_option( 'af_tbw_tipping_or_donation_heading_text', 'tip/donate' );
				$af_tbw_fixed_predefiend_values                = get_option( 'af_tbw_fixed_placeholder', '5,10,15' );

				if ( 'fixed' === $af_tbw_tipping_or_donation_type ) {

					switch ( $af_tbw_tipping_or_donation_precentage_options ) {

						case 'radio_btn':
							$adf_checkout_block .='<div class="popup-heading"><h3>' . esc_html( $af_tbw_tipping_or_donation_heading_text ) . '</h3><p>' . wp_kses_post( $af_tbw_tipping_or_donation_message_text ) . '</p></div>';
							if ( $af_tbw_fixed_predefiend_values ) {
								$af_radiobutton_fixed_values = explode( ',', $af_tbw_fixed_predefiend_values );
								$af_radiobutton_fixed_values = array_unique( $af_radiobutton_fixed_values );
								$adf_checkout_block         .='<div class="adf-radio-btn-tempalte-wrap">';
								foreach ( $af_radiobutton_fixed_values as $af_radiobutton_fixed_value ) {
									$adf_checkout_block .= '<div class="adf-radio-btn">';
									$adf_checkout_block .='<label class="af_tbw_label_css_setting">';
									$adf_checkout_block .='<input type="radio" class="af_tbw_radio_button_fixed"' . esc_attr( $af_radiobutton_fixed_value == $type ? 'checked' : '' ) . ' name="af_tbw_radio_button_fixed_option" value="' . esc_attr( $af_radiobutton_fixed_value ) . '" data-af_tbw_radio_btn_fixed="' . esc_attr( $af_radiobutton_fixed_value ) . '">';
									$adf_checkout_block .='<span style="margin-left:5px;"class="af_tbw_radio_button_text">' . get_woocommerce_currency_symbol() . ' ' . esc_attr( $af_radiobutton_fixed_value ) . '</span>';
									$adf_checkout_block .='</label></div>';
								}
								$adf_checkout_block         .='<div class="adf-radio-btn">';
									$adf_checkout_block     .='<label class="af_tbw_label_css_setting" >';
										$adf_checkout_block .='<input type="radio" class="fixed-other" name="af_tbw_radio_button_fixed_option"' . esc_attr( 'others' == $type ? 'checked' : '' ) . ' value="others">';
										$adf_checkout_block .='<span class="af_radio_button_text" >' . ( $af_td_other_btn_text ? esc_html($af_td_other_btn_text) : 'other' ) . '</span>';
									$adf_checkout_block     .='</label>';
								$adf_checkout_block         .='</div>';
								$adf_checkout_block         .='</div>';
								$adf_checkout_block         .='<div class="af_tbw_other_options_fixed" style="display:none; margin-top:8px">';
									$adf_checkout_block     .='<input type="number" class="af_tbw_fixed_amount_donate"  name="af_tbw_fixed_amount" min="0" value="' . esc_attr( $custom_value ) . '" placeholder="' . ( $af_td_other_field_place_holder ? esc_attr($af_td_other_field_place_holder):'Add amount' ) . '">';
									$adf_checkout_block     .='<button type="button" class="button alt af_tbw_donate_button" name="tipping_donation">' . esc_html( $af_tbw_tipping_or_donation_button_text ) . '</button>';
								$adf_checkout_block         .='</div>';
							}
							break;
						case 'Buttons':
							$adf_checkout_block .='<div class="popup-heading"><h3>' . esc_html( $af_tbw_tipping_or_donation_heading_text ) . '</h3><p>' . wp_kses_post( $af_tbw_tipping_or_donation_message_text ) . '</p></div>';
							$adf_checkout_block .= '<div class="adf-button-tempalte-wrap">';
							if ( $af_tbw_fixed_predefiend_values ) {
								$af_button_fixed_values = explode( ',', $af_tbw_fixed_predefiend_values );
								$af_button_fixed_values = array_unique( $af_button_fixed_values );
								foreach ( $af_button_fixed_values as $af_button_fixed_value ) {
									$adf_checkout_block .='<button  type="button" class="button alt af_tbw_btn_donate_fixed_button" data-af_tbw_fixed_btn="' . esc_attr( $af_button_fixed_value ) . '" name="button_percentage">' . get_woocommerce_currency_symbol() . ' ' . esc_attr( $af_button_fixed_value ) . '</button>';
								}
							}
							$adf_checkout_block     .='<button type="button" class="button alt fixed-other">' . ( $af_td_other_btn_text ? esc_html($af_td_other_btn_text) : 'other' ) . '</button>';
							$adf_checkout_block     .= '</div>';
							$adf_checkout_block     .= '<div class="af_tbw_other_options_fixed" style="display:none; margin-top:8px">';
								$adf_checkout_block .= '<input type="number" class="af_tbw_fixed_amount_donate" name="af_tbw_fixed_amount" min="0" placeholder="' . ( $af_td_other_field_place_holder ? esc_attr($af_td_other_field_place_holder):'Add amount' ) . '">';
								$adf_checkout_block .= '<button type="button" class="button alt af_tbw_donate_button" name="tipping_donation">' . esc_html( $af_tbw_tipping_or_donation_button_text ) . '</button>';
							$adf_checkout_block     .= '</div>';
							break;
						case 'popup':
							$adf_checkout_block     .='<div class="adf-main-popup">
						   	  <i class="af-close-popup">×</i>
						   	  <div class="adf-popup-wrap">';
								$adf_checkout_block .='<div class="popup-heading"><h3>' . esc_html( $af_tbw_tipping_or_donation_heading_text ) . '</h3><p>' . wp_kses_post( $af_tbw_tipping_or_donation_message_text ) . '</p></div>';
								$adf_checkout_block .='<div class="adf-popup-pre-defined-value">';
							if ( $af_tbw_fixed_predefiend_values ) {
								$af_button_fixed_values = explode( ',', $af_tbw_fixed_predefiend_values );
								$af_button_fixed_values = array_unique( $af_button_fixed_values );
								foreach ( $af_button_fixed_values as $af_button_fixed_value ) {
									$adf_checkout_block .='<label class="adf-popup-options">';
									$adf_checkout_block .='<input type="radio" class="af_tbw_popup_button"' . esc_attr( $af_button_fixed_value == $type ? 'checked' : '' ) . ' name="af_tbw_button_fixed_popup" value="' . esc_attr( $af_button_fixed_value ) . '" data-af_tbw_popup="' . esc_attr( $af_button_fixed_value ) . '">';
									$adf_checkout_block .='<span class="af_tbw_popup_button_text">' . esc_attr( get_woocommerce_currency_symbol() ) . ' ' . esc_attr( $af_button_fixed_value ) . '</span></label>';
								}
							}

							$adf_checkout_block         .='</div>';
							$adf_checkout_block         .='<div class="adf_popup-other-field-percentage">';
							$adf_checkout_block         .='<input type="number" value="' . esc_attr( $custom_value ) . '" class="af_tbw_fixed_amount" name="af_tbw_fixed_amount" min="0" placeholder="' . ( $af_td_other_field_place_holder ? esc_attr($af_td_other_field_place_holder):'Add amount' ) . '">';
							$adf_checkout_block         .='</div>';
							$adf_checkout_block         .='<div class="af_tbw_other_options_percentage_popup" style="margin-top:15px">';
								$adf_checkout_block     .='<button type="button" class="button alt af_tbw_popup_fixed">' . esc_html( $af_tbw_tipping_or_donation_button_text ) . '</button>';
									$adf_checkout_block .='<button type="button" class="button alt af_tbw_removedata" style="display: none;">' . esc_html__('Remove', 'addify-tipping-at-cart-checkout') . '</button>';
								$adf_checkout_block     .='</div>';
							$adf_checkout_block         .='</div></div>';
							break;
						default:
							$adf_checkout_block .='<div class="popup-heading"><h3>' . esc_html( $af_tbw_tipping_or_donation_heading_text ) . '</h3><p>' . wp_kses_post( $af_tbw_tipping_or_donation_message_text ) . '</p></div>';
							if ( $af_tbw_fixed_predefiend_values ) {
								$adf_checkout_block               .='<div class="af_tbw_other_options_fixed_wrap"><select  class="af_tbw_select_fixed" name="af_tbw_fixed_select">';
									$af_tbw_selectbox_fixed_values = explode( ',', $af_tbw_fixed_predefiend_values );
									$af_tbw_selectbox_fixed_values = array_unique( $af_tbw_selectbox_fixed_values );
								foreach ( $af_tbw_selectbox_fixed_values as $af_selectbox_fixed_value ) {
									$selected            = ( $af_selectbox_fixed_value == $type ) ? ' selected' : '';
									$adf_checkout_block .= '<option' . esc_attr($selected) . ' class="af_tbw_select_option_percentage" value="' . esc_attr($af_selectbox_fixed_value) . '" data-id="' . esc_attr($af_selectbox_fixed_value) . '">' . get_woocommerce_currency_symbol() . ' ' . esc_html($af_selectbox_fixed_value) . '</option>';
								}
									$adf_checkout_block .= '<option' . esc_attr('others' == $type ? ' selected' : '') . ' class="af_tbw_select_option_percentage" value="others">' . esc_html($af_td_other_btn_text ? $af_td_other_btn_text : 'other') . '</option>';
								$adf_checkout_block     .='</select>';
								$adf_checkout_block     .='<button type="button" class="button alt af_tbw_select_fixed_btn" >' . esc_html( $af_tbw_tipping_or_donation_button_text ) . '</button>';
								$adf_checkout_block     .='</div>';

								$adf_checkout_block .='<div class="adf-tip-others-btn">';
								$adf_checkout_block .='<input type="number" class="af_tbw_fixed_amount_donate af_tbw_other_options_fixed" name="af_tbw_fixed_amount" min="0" placeholder="' . ( $af_td_other_field_place_holder ? esc_attr($af_td_other_field_place_holder):'Add amount' ) . '" style="display:none;">';
								$adf_checkout_block .='<button type="button" class="button alt af_tbw_donate_button af_tbw_other_options_fixed" name="tipping_donation" style="display:none;">' . esc_html( $af_tbw_tipping_or_donation_button_text ) . '</button>';
								$adf_checkout_block .='</div>';
							}
							break;
					}
					
				} elseif ( 'percentage' === $af_tbw_tipping_or_donation_type ) {

					switch ( $af_tbw_tipping_or_donation_precentage_options ) {

						case 'radio_btn':
						$adf_checkout_block .='<div class="popup-heading"><h3>' . esc_html( $af_tbw_tipping_or_donation_heading_text ) . '</h3><p>' . wp_kses_post( $af_tbw_tipping_or_donation_message_text ) . '</p></div>';
							if ( $af_tbw_percentage_predefiend_values ) {
								$af_radiobutton_percentage_values = explode( ',', $af_tbw_percentage_predefiend_values );
								$af_radiobutton_percentage_values = array_unique( $af_radiobutton_percentage_values );
								$adf_checkout_block              .='<div class="adf-radio-btn-tempalte-wrap">';
								foreach ( $af_radiobutton_percentage_values as $af_radiobutton_percentage_value ) {
									$adf_checkout_block         .='<div class="adf-radio-btn">';
										$adf_checkout_block     .='<label class="af_tbw_label_css_setting">';
										$adf_checkout_block     .='<input type="radio" class="af_tbw_radio_button"' . esc_attr( $af_radiobutton_percentage_value == $type ? 'checked' : '' ) . ' name="af_tbw_radio_button_percentage_option" value="' . esc_attr( $af_radiobutton_percentage_value ) . '" data-af_tbw_radio_btn="' . esc_attr( $af_radiobutton_percentage_value ) . '">';
											$adf_checkout_block .='<span style="margin-left:5px;"class="af_tbw_radio_button_text">' . esc_attr( $af_radiobutton_percentage_value ) . ' %</span>';
											$adf_checkout_block .='</label>';
									$adf_checkout_block         .='</div>';
								}
								$adf_checkout_block         .='<div class="adf-radio-btn">';
									$adf_checkout_block     .='<label class="af_tbw_label_css_setting">';
									$adf_checkout_block     .='<input type="radio" class="other" name="af_tbw_radio_button_percentage_option"' . esc_attr( 'others' == $type ? 'checked' : '' ) . ' value="others">';
										$adf_checkout_block .='<span class="af_radio_button_text" >' . ( $af_td_other_btn_text ? esc_html($af_td_other_btn_text) : 'other' ) . '</span>';
										$adf_checkout_block .='</label>';
									$adf_checkout_block     .='</div>'; 
								$adf_checkout_block         .='</div>';
								$adf_checkout_block         .='<div class="af_tbw_other_options" style="display:none; margin-top:8px">';
									$adf_checkout_block     .='<input type="number" value="' . esc_attr( $custom_value ) . '"  class="af_tbw_other_percentage" name="af_tbw_other_percentage"  min="0" placeholder="' . ( $af_td_other_field_place_holder ? esc_attr($af_td_other_field_place_holder):'Add amount' ) . '" >';
									$adf_checkout_block     .='<button type="button" class="button alt af_tbw_other_percent">' . esc_html( $af_tbw_tipping_or_donation_button_text ) . '</button>';
								$adf_checkout_block         .='</div>';                            
							}
							break;
						case 'Buttons':
							$adf_checkout_block .='<div class="popup-heading"><h3>' . esc_html( $af_tbw_tipping_or_donation_heading_text ) . '</h3><p>' . wp_kses_post( $af_tbw_tipping_or_donation_message_text ) . '</p></div>';
							$adf_checkout_block .= '<div class="adf-button-tempalte-wrap">';
							if ( $af_tbw_percentage_predefiend_values ) {
								$af_button_percentage_values = explode( ',', $af_tbw_percentage_predefiend_values );
								$af_button_percentage_values = array_unique( $af_button_percentage_values );
								foreach ( $af_button_percentage_values as $af_button_percentage_value ) {
									$adf_checkout_block .='<button  type="button" class="button alt af_tbw_btn_donate_button" data-af_tbw_percentage_btn="' . esc_attr( $af_button_percentage_value ) . '" name="button_percentage">' . esc_attr( $af_button_percentage_value ) . ' %</button>';
								}
							}
							$adf_checkout_block .='<button type="button" class="button alt other">' . ( $af_td_other_btn_text ? esc_html($af_td_other_btn_text) : 'other' ) . '</button>';
							$adf_checkout_block .= '</div>';
							$adf_checkout_block .='<div class="af_tbw_other_options" style="display:none; margin-top:8px">';
							$adf_checkout_block .='<input type="number" value="' . esc_attr( $custom_value ) . '" class="af_tbw_other_percentage" name="af_tbw_other_percentage" min="0" placeholder="' . ( $af_td_other_field_place_holder ? esc_attr($af_td_other_field_place_holder):'Add amount' ) . '">';
							$adf_checkout_block .='<button type="button" class="button alt af_tbw_other_percent">' . esc_html( $af_tbw_tipping_or_donation_button_text ) . '</button>';
							$adf_checkout_block .='</div>';
							break;
						case 'popup':
							$adf_checkout_block     .='<div class="adf-main-popup">';
							$adf_checkout_block     .='<i class="af-close-popup ">×</i><div class="adf-popup-wrap">';
								$adf_checkout_block .='<div class="popup-heading"><h3>' . esc_html( $af_tbw_tipping_or_donation_heading_text ) . '</h3><p>' . wp_kses_post( $af_tbw_tipping_or_donation_message_text ) . '</p></div>';
								$adf_checkout_block .='<div class="adf-popup-pre-defined-value">';
							if ( $af_tbw_percentage_predefiend_values ) {
								$af_button_percentage_values = explode( ',', $af_tbw_percentage_predefiend_values );
								$af_button_percentage_values = array_unique( $af_button_percentage_values );
								foreach ( $af_button_percentage_values as $af_button_percentage_value ) {
									$adf_checkout_block     .='<label class="adf-popup-options"><input type="radio" class="af_tbw_popup_button"' . esc_attr( $af_button_percentage_value == $type ? 'checked' : '' ) . ' name="af_tbw_button_percentage_popup" value="' . esc_attr( $af_button_percentage_value ) . '" data-af_tbw_popup="' . esc_attr( $af_button_percentage_value ) . '">';
										$adf_checkout_block .='<span class="af_tbw_popup_button_text">' . esc_attr( $af_button_percentage_value ) . '%</span>';
										$adf_checkout_block .='</label>';
								}
							}
							$adf_checkout_block                .='</div>';
							$adf_checkout_block                .='<div class="adf_popup-other-field-percentage">';
								$af_td_other_field_place_holder = get_option('af_td_other_field_place_holder');
							$adf_checkout_block                .='<input type="number" value="' . esc_attr( $custom_value ) . '" class="af_tbw_other_percentage" name="af_tbw_other_percentage"  min="0" placeholder="' . ( $af_td_other_field_place_holder ? esc_attr($af_td_other_field_place_holder):'Add amount' ) . '" >';
							$adf_checkout_block                .='</div>';
							$adf_checkout_block                .='<div class="af_tbw_other_options_percentage_popup" style="margin-top:15px">
										<button type="button" class="button alt af_tbw_popup_percent" >' . esc_html( $af_tbw_tipping_or_donation_button_text ) . '</button>';
									$adf_checkout_block        .='<button type="button" class="button alt af_tbw_removedata" style="display: none;">' . esc_html__('Remove', 'addify-tipping-at-cart-checkout') . '</button>';
								$adf_checkout_block            .='</div>';
								$adf_checkout_block            .='</div></div>';
							break;
						default:
						$adf_checkout_block .='<div class="popup-heading"><h3>' . esc_html( $af_tbw_tipping_or_donation_heading_text ) . '</h3><p>' . wp_kses_post( $af_tbw_tipping_or_donation_message_text ) . '</p></div>';
							if ( $af_tbw_percentage_predefiend_values ) {
								$adf_checkout_block                .='<div class="af_tbw_other_options_fixed_wrap"><select  class="af_tbw_Select_percentage" name="af_tbw_fixed_select">';
								$af_tbw_selectbox_percentage_values = explode( ',', $af_tbw_percentage_predefiend_values );
								$af_tbw_selectbox_percentage_values = array_unique( $af_tbw_selectbox_percentage_values );
								foreach ( $af_tbw_selectbox_percentage_values as $af_selectbox_percentage_value ) {
									$selected            = ( $af_selectbox_percentage_value == $type ) ? ' selected' : '';
									$adf_checkout_block .= '<option' . esc_attr($selected) . ' class="af_tbw_select_option_percentage" value="' . esc_attr($af_selectbox_percentage_value) . '" data-id="' . esc_attr($af_selectbox_percentage_value) . '">' . esc_html($af_selectbox_percentage_value) . ' %</option>';
								}

								$adf_checkout_block .= '<option' . esc_attr('others' == $type ? ' selected' : '' ) . ' class="af_tbw_select_option_percentage" value="others">' . esc_html($af_td_other_btn_text ? $af_td_other_btn_text : 'other') . '</option>';
							$adf_checkout_block     .='</select>';
							$adf_checkout_block     .='<button type="button" class="button alt af_tbw_select_percentage">' . esc_html( $af_tbw_tipping_or_donation_button_text ) . '</button>';
							$adf_checkout_block     .='</div>';
							$adf_checkout_block     .='<div class="adf-tip-others-btn">';
							$adf_checkout_block     .='<input type="number" value="' . esc_attr( $custom_value ) . '" class="af_tbw_other_percentage af_tbw_other_options" name="af_tbw_other_percentage" min="0" placeholder="' . ( $af_td_other_field_place_holder ? esc_attr($af_td_other_field_place_holder):'Add amount' ) . '" style="display:none;">';
							$adf_checkout_block     .='<button type="button" class="button alt af_tbw_other_percent af_tbw_other_options" style="display:none;">' . esc_html( $af_tbw_tipping_or_donation_button_text ) . '</button>';
							$adf_checkout_block     .='</div>';
							
							}
							break;
					}
				}
				$adf_checkout_block .='</div>';
			} else {
				$this->af_tbw_session_unset();
			}
			
			$checkout_data                     = array();
			$message_position_checkout         = get_option('af_tbw_tipping_or_donation_on_checkout_page_display_option');
			$af_tbw_tipping_or_donation_feilds = get_option('af_tbw_tipping_or_donation_feilds');
			if ( 'both_cart_and_checkout' === $af_tbw_tipping_or_donation_feilds || 'checkout_only' === $af_tbw_tipping_or_donation_feilds ) {
				$checkout_data = array(
					'checkout_block_content'    => !empty($adf_checkout_block) ? $adf_checkout_block : '',
					'message_position_checkout' => $message_position_checkout,
				);
			
				wp_localize_script( 'front-block-script', 'afwtd_checkout_data', $checkout_data );
			} else {
				wp_localize_script( 'front-block-script', 'afwtd_checkout_data', $checkout_data );
			}
		}
		public function af_tbw_save_tipping_donation_in_reports_table( $order_id ) {

			if ( 0 !== ( WC()->session->get( 'af_tbw_tipping_donation_percentage_calculated' ) ) ) {

				$af_get_percentage_tipping_amount = WC()->session->get( 'af_tbw_tipping_donation_percentage_calculated' );
				$post_data                        = array(
					'post_type'   => 'donation_total',
					'post_status' => 'publish',
					'meta_input'  => array(
						'order_id'               => $order_id,
						'tipping_donation_total' => $af_get_percentage_tipping_amount,
					),
				);
				wp_insert_post( $post_data );
				$this->af_tbw_session_unset();

			}

			if ( 0 !== ( WC()->session->get( 'af_tbw_tipping_donation_fixed' ) ) ) {
				$af_get_fixed_tipping_amount = WC()->session->get( 'af_tbw_tipping_donation_fixed' );
				$post_data                   = array(
					'post_type'   => 'donation_total',
					'post_status' => 'publish',
					'meta_input'  => array(
						'order_id'               => $order_id,
						'tipping_donation_total' => $af_get_fixed_tipping_amount,
					),
				);
				wp_insert_post( $post_data );
				$this->af_tbw_session_unset();
			}
		}
		public function af_tbw_session_unset() {
			WC()->session->set( 'af_tbw_is_percent_calcultated', 0 );
			WC()->session->set( 'af_tbw_tipping_donation_percentage', 0 );
			WC()->session->set( 'af_tbw_tipping_donation_fixed', 0 );
			WC()->session->set( 'af_tbw_tipping_donation_percentage_calculated', 0 );
		}
		public function af_tbw_check_restrictions() {

			$af_tbw_products_tipping_or_donation_restriction_product_ids         = (array) get_option( 'af_tbw_products_tipping_or_donation_restriction_product_ids' );
			$af_tbw_categories_tipping_donation_restriction_category_ids         = (array) get_option( 'af_tbw_categories_tipping_donation_restriction_category_ids' );
			$af_tbw_shipping_tipping_or_donation_restriction_shipping_method_ids = (array) get_option( 'af_tbw_shipping_tipping_or_donation_restriction_shipping_method_ids' );

			$af_tbw_user_selected_shipping_method_id = '';
			if ( ! empty( WC()->session->get( 'chosen_shipping_methods' ) ) ) {
				$adf_shipping_method = WC()->session->get( 'chosen_shipping_methods' );
				if ( isset( explode( ':', reset($adf_shipping_method ) )[0] ) ) {
					$af_tbw_user_selected_shipping_method_id = explode( ':', reset( $adf_shipping_method ) )[0];
				}
			}

			if ( ( in_array( $af_tbw_user_selected_shipping_method_id, $af_tbw_shipping_tipping_or_donation_restriction_shipping_method_ids ) ) ) {

				return true;
			}
			// outer foreach that iterates for cart produt ids.
			foreach ( WC()->cart->get_cart() as $af_tbw_item_key => $af_tbw_cart_item ) {

				if ( in_array( $af_tbw_cart_item['product_id'], $af_tbw_products_tipping_or_donation_restriction_product_ids ) ) {

					return true;
				}
				// inner foreach that iterates for cart categories ids using single prduct id.
				foreach ( $af_tbw_categories_tipping_donation_restriction_category_ids as $af_tbw_catid ) {

					if ( has_term( $af_tbw_catid, 'product_cat', $af_tbw_cart_item['product_id'] ) ) {

						return true;
					}
				}
			}
		}
	}
}
