<?php
/**
 * File containing the _tipping_donation_Front class.
 *
 * @package addify-tipping-at-cart-checkout
 */

if ( ! defined( 'ABSPATH' ) ) {
	die;
}
/**
 * Class Af_tipping_donation_Admin
 */
class AF_Woo_Tipping_Or_Donation_Admin {
	/**
	 * Construct().
	 */
	public function __construct() {

		add_filter( 'woocommerce_settings_tabs_array', array( $this, 'af_tbw_add_settings_tab' ), 50 );
		add_action( 'woocommerce_settings_tabs_af_tipping_or_donation_woocommerce_settings', array( $this, 'af_tbw_settings_tab_content' ) );
		add_action( 'woocommerce_settings_af_tipping_or_donation_woocommerce_settings_restriction', array( $this, 'af_tbw_restriction_content' ) );
		add_action( 'woocommerce_settings_af_tipping_or_donation_woocommerce_settings_style', array( $this, 'af_tbw_style_content' ) );
		add_action( 'woocommerce_settings_af_tipping_or_donation_woocommerce_settings_report', array( $this, 'af_tbw_report_content' ) );
		add_action( 'woocommerce_update_options_af_tipping_or_donation_woocommerce_settings', array( $this, 'af_tbw_save_settings' ) );
		add_action( 'admin_enqueue_scripts', array( $this, 'af_tbw_admin_enqueue_scripts' ) );
		add_action( 'wp_ajax_af_tbw_product_disp', array( $this, 'af_tbw_product_disp' ) );
	}
	/**
	 * Af_tbw_add_settings_tab
	 *
	 * @param array $tabs return tabs .
	 */
	public function af_tbw_add_settings_tab( $tabs ) {
		$tabs['af_tipping_or_donation_woocommerce_settings'] = __( 'Tipping at Cart & Checkout', 'addify-tipping-at-cart-checkout' );
		return $tabs;
	}

	/**
	 * Af_tbw_settings_tab_content
	 */
	public function af_tbw_settings_tab_content() {
		if ( isset( $_POST['af_tbw_settings_nonce'] ) && ! empty( $_POST['af_tbw_settings_nonce'] ) ) {
			if ( ! check_admin_referer( 'af_tbw_tipping_donation_setting', 'af_tbw_settings_nonce' ) ) {
				// Nonce verification failed
				wp_die( 'Nonce verification failed. Please try again.' );
			}
		}
		$af_tbw_current_section = isset( $_GET['section'] ) ? sanitize_text_field( wp_unslash( $_GET['section'] ) ) : 'settings';
		?>
		<ul class="subsubsub">
			<li><a href="?page=wc-settings&tab=af_tipping_or_donation_woocommerce_settings&section=settings" class="<?php echo ( 'settings' === $af_tbw_current_section ) ? 'current' : ''; ?>"><?php esc_html_e( 'Settings', 'addify-tipping-at-cart-checkout' ); ?></a> |</li>
			<li><a href="?page=wc-settings&tab=af_tipping_or_donation_woocommerce_settings&section=restriction" class="<?php echo ( 'restriction' === $af_tbw_current_section ) ? 'current' : ''; ?>"><?php esc_html_e( 'Restrictions', 'addify-tipping-at-cart-checkout' ); ?></a> |</li>
			<li><a href="?page=wc-settings&tab=af_tipping_or_donation_woocommerce_settings&section=style" class="<?php echo ( 'style' === $af_tbw_current_section ) ? 'current' : ''; ?>"><?php esc_html_e( 'Style', 'addify-tipping-at-cart-checkout' ); ?></a> |</li>
			<li><a href="?page=wc-settings&tab=af_tipping_or_donation_woocommerce_settings&section=report" class="<?php echo ( 'report' === $af_tbw_current_section ) ? 'current' : ''; ?>"><?php esc_html_e( 'Report', 'addify-tipping-at-cart-checkout' ); ?></a></li>
		</ul><br><br>
		<?php
			wp_nonce_field( 'af_tbw_tipping_donation_setting', 'af_tbw_settings_nonce' );
		if ( 'settings' === $af_tbw_current_section ) {
				$this->af_tbw_tipping_donation_settings_content();
		} elseif ( 'restriction' === $af_tbw_current_section ) {
			$this->af_tbw_restriction_content();
		} elseif ( 'style' === $af_tbw_current_section ) {
			$this->af_tbw_style_content();
		} elseif ( 'report' === $af_tbw_current_section ) {
			$this->af_tbw_report_content();
			
			?>
				<style>
					.woocommerce-save-button {
						display:none ! important;		
					}
				</style>
			<?php
		}
	}
	/**
	 * Af_tbw_settings_tab_content
	 */
	public function af_tbw_tipping_donation_settings_content() {
		if ( isset( $_POST['af_tbw_settings_nonce'] ) && ! empty( $_POST['af_tbw_settings_nonce'] ) ) {
			if ( ! check_admin_referer( 'af_tbw_tipping_donation_setting', 'af_tbw_settings_nonce' ) ) {
				// Nonce verification failed
				wp_die( 'Nonce verification failed. Please try again.' );
			}
		}
		$af_tbw_current_section = isset( $_GET['section'] ) ? sanitize_text_field( wp_unslash( $_GET['section'] ) ) : 'settings';

		if ( 'settings' === $af_tbw_current_section ) {
			$enable_tipping_or_donation                             = get_option( 'af_tbw_enable_tipping_or_donation' );
			$tipping_or_donation_option                             = get_option( 'af_tbw_tipping_or_donation_type', 'fixed' );
			$af_tbw_tipping_or_donation_precentage_options          = get_option( 'af_tbw_tipping_or_donation_precentage_options', 'select_box' );
			$percentage_options                                     = get_option( 'af_tbw_percentage_predefiend_values' );
			$percentage_options                                     = implode( ',', array_unique( explode( ',', $percentage_options ) ) );
			$fixed_placeholder                                      = get_option( 'af_tbw_fixed_placeholder' );
			$af_tbw_tipping_or_donation_feilds                      = get_option( 'af_tbw_tipping_or_donation_feilds' );
			$af_tbw_tipping_or_donation_on_cart_page_display_option = get_option( 'af_tbw_tipping_or_donation_on_cart_page_display_option', 'before cart table' );
			$af_tbw_tipping_or_donation_on_checkout_page_display_option = get_option( 'af_tbw_tipping_or_donation_on_checkout_page_display_option', 'before checkout form' );
			$af_tbw_tipping_or_donation_button_text                     = get_option( 'af_tbw_tipping_or_donation_button_text' );
			$af_tbw_tipping_or_donation_message_text                    = get_option( 'af_tbw_tipping_or_donation_message_text' );
			$af_tipping_or_donation_summary_title                       = get_option( 'af_tipping_or_donation_summary_title' );
			$af_tbw_enable_tipping_or_donation_taxable                  = get_option( 'af_tbw_enable_tipping_or_donation_taxable' );
			?>
			<div class="wrap woocommerce">
				<h1><?php echo esc_html__( 'Settings', 'addify-tipping-at-cart-checkout' ); ?></h1>
				<table class="form-table">
					<tr valign="top">
						<th scope="row"><?php echo esc_html__( 'Enable tipping extension:', 'addify-tipping-at-cart-checkout' ); ?></th>
						<td>
							<label for="af_tbw_enable_tipping_or_donation">
								<input type="checkbox" name="af_tbw_enable_tipping_or_donation" id="af_tbw_enable_tipping_or_donation" value="yes" 
								<?php
								checked(
									$enable_tipping_or_donation,
									'yes'
								);
								?>
																																					>
								<?php echo esc_html__( 'Yes', 'addify-tipping-at-cart-checkout' ); ?>
							</label>
							<p> <?php echo esc_html__( 'Check this option to start collecting tipping at cart and checkout.', 'addify-tipping-at-cart-checkout' ); ?></p>
						</td>
						
					</tr>
					<tr valign="top">
						<th scope="row"><?php echo esc_html__( 'Show tipping options on:', 'addify-tipping-at-cart-checkout' ); ?></th>
						<td>
							<select class="af_tbw_tipping_or_donation_feilds" name="af_tbw_tipping_or_donation_feilds">
								<option value="both_cart_and_checkout" <?php selected( $af_tbw_tipping_or_donation_feilds, 'both_cart_and_checkout' ); ?>><?php echo esc_html__( 'Both Cart and Checkout', 'addify-tipping-at-cart-checkout' ); ?></option>
								<option value="cart_only" <?php selected( $af_tbw_tipping_or_donation_feilds, 'cart_only' ); ?>><?php echo esc_html__( 'Cart Only', 'addify-tipping-at-cart-checkout' ); ?></option>
								<option value="checkout_only" <?php selected( $af_tbw_tipping_or_donation_feilds, 'checkout_only' ); ?>><?php echo esc_html__( 'Checkout Only', 'addify-tipping-at-cart-checkout' ); ?></option>
							</select>
							<p><?php echo esc_html__( 'Choose whether to show tipping box on cart, checkout or both pages.', 'addify-tipping-at-cart-checkout' ); ?></p>
						</td>
					</tr>
					<tr class="tipping_postion_on_cart" valign="top">
						<th scope="row"><?php echo esc_html__( 'Tipping box position on cart page:', 'addify-tipping-at-cart-checkout' ); ?></th>
						<td>
				<select  name="af_tbw_tipping_or_donation_on_cart_page_display_option">
					<?php
							$af_cart_page_display_options = array(
								'Before Cart Table' => 'woocommerce_before_cart',
								'After Cart Table'  => 'woocommerce_before_cart_collaterals',
								'After Cart'        => 'woocommerce_after_cart',
							);

							foreach ( $af_cart_page_display_options as $label => $value ) {
								$selected = selected( $af_tbw_tipping_or_donation_on_cart_page_display_option, $value, false );
								echo '<option value="' . esc_html( $value ) . '" ' . esc_html( $selected ) . '>' . esc_html( $label ) . '</option>';
							}
							?>
				</select>
				<p><?php echo esc_html__( 'Choose appropriate position for tipping box on cart page.', 'addify-tipping-at-cart-checkout' ); ?></p>
				</td>
			</tr>
			<tr class="tipping_postion_on_checkout" valign="top">
				<th scope="row"><?php echo esc_html__( 'Tipping box position on checkout page:', 'addify-tipping-at-cart-checkout' ); ?></th>
						<td>
						<select name="af_tbw_tipping_or_donation_on_checkout_page_display_option">
					<?php
						$checkout_options = array(
							// 'Before checkout form' => 'woocommerce_before_checkout_form',
							'Before Checkout Customer Details' => 'woocommerce_checkout_before_customer_details',
							'Before Checkout Billing Form' => 'woocommerce_before_checkout_billing_form',
							'After Checkout Billing Form'  => 'woocommerce_after_checkout_billing_form',
							'Before Order Notes'           => 'woocommerce_before_order_notes',
							'After Order Notes'            => 'woocommerce_after_order_notes',
							'After Checkout Form'          => 'woocommerce_after_checkout_form',
						);

						foreach ( $checkout_options as $checkout_label => $checkout_value ) {
							$checkout_selected = selected( $af_tbw_tipping_or_donation_on_checkout_page_display_option, $checkout_value, false );
							echo '<option value="' . esc_html( $checkout_value ) . '" ' . esc_html( $checkout_selected ) . '>' . esc_html( $checkout_label ) . '</option>';
						}
						?>
						</select> 
						<p><?php echo esc_html__( 'Choose appropriate position for tipping box on checkout page.', 'addify-tipping-at-cart-checkout' ); ?></p>
					</td>
						</tr>
						<tr valign="top">
						<th scope="row"><?php echo esc_html__( 'Tipping section heading:', 'addify-tipping-at-cart-checkout' ); ?></th>
							<td>
							<?php
							$af_tbw_tipping_or_donation_heading_text = get_option( 'af_tbw_tipping_or_donation_heading_text' );
							?>
							<input type="text" id="af_tbw_tipping_or_donation_heading_text"  name="af_tbw_tipping_or_donation_heading_text"required value="<?php echo $af_tbw_tipping_or_donation_heading_text ? esc_attr( $af_tbw_tipping_or_donation_heading_text ): 'Add Tip'; ?>">
							<p><?php echo esc_html__( 'Add a heading for tipping box.', 'addify-tipping-at-cart-checkout' ); ?></p>
			</td>
		</tr>
						<tr valign="top">
						<th scope="row"><?php echo esc_html__( 'Tipping section description:', 'addify-tipping-at-cart-checkout' ); ?></th>
							<td>
							<?php
							$af_tbw_tipping_or_donation_message_text = get_option( 'af_tbw_tipping_or_donation_message_text' );
							?>
							<textarea id="af_tbw_tipping_or_donation_message_text"  name="af_tbw_tipping_or_donation_message_text" style="height:95px;" required><?php echo $af_tbw_tipping_or_donation_message_text ? esc_attr( $af_tbw_tipping_or_donation_message_text ):'Include a tip in your order.'; ?></textarea>			  <p><?php echo esc_html__( 'Add a description for tipping box.', 'addify-tipping-at-cart-checkout' ); ?></p>
			</td>
		</tr>
			
				<tr valign="top">
							<th scope="row"><?php echo esc_html__( 'Tipping button text:', 'addify-tipping-at-cart-checkout' ); ?></th>
							<td>
							<input type="text" name="af_tbw_tipping_or_donation_button_text" id="af_tbw_tipping_or_donation_button_text" placeholder="Add" value="<?php echo esc_attr( $af_tbw_tipping_or_donation_button_text ? $af_tbw_tipping_or_donation_button_text : 'Add' ); ?>" required>
							<p><?php echo esc_html__( 'Change the “add” tip button text to donation or add a tip.', 'addify-tipping-at-cart-checkout' ); ?></p>
							</td>
				</tr>

				<tr valign="top">
						<th scope="row"><?php echo esc_html__( 'Tipping type:', 'addify-tipping-at-cart-checkout' ); ?></th>
						<td>
							<select class="af_tbw_tipping_or_donation_type" name="af_tbw_tipping_or_donation_type">
								<option value="fixed" <?php selected( $tipping_or_donation_option, 'fixed' ); ?>><?php echo esc_html__( 'Fixed', 'addify-tipping-at-cart-checkout' ); ?></option>
								<option value="percentage" <?php selected( $tipping_or_donation_option, 'percentage' ); ?>><?php echo esc_html__( 'Percentage', 'addify-tipping-at-cart-checkout' ); ?></option>
							</select>
							<p><?php echo esc_html__( 'Choose whether to collect tipping in fixed amounts or a percentage of the cart amount.', 'addify-tipping-at-cart-checkout' ); ?></p>
						</td>
					</tr>
					<tr class="tipping_fixed_row" valign="top">
						<th scope="row"><?php echo esc_html__( 'Tipping fix amount options:', 'addify-tipping-at-cart-checkout' ); ?></th>
						<td>
						<input type="text" name="af_tbw_fixed_placeholder" pattern="^[1-9]\d*(,[1-9]\d*)*$" id="af_tbw_fixed_placeholder" placeholder="5,10,15,20,25,30,35,40" value="<?php echo $fixed_placeholder ? esc_attr( $fixed_placeholder ) : '5,10,15,20,25,30,35,40'; ?>" required>
						<p><?php echo esc_html__( 'Add multiple fixed tip amount options separated by comma (,).', 'addify-tipping-at-cart-checkout' ); ?></p>
						</td>
					</tr>
					<tr class="tipping_percentage_row" valign="top">
						<th scope="row"><?php echo esc_html__( 'Tipping percentage options:', 'addify-tipping-at-cart-checkout' ); ?></th>
						<td>
							<input type="text" name="af_tbw_percentage_predefiend_values" pattern="^[1-9]\d*(,[1-9]\d*)*$" id="af_tbw_percentage_predefiend_values" placeholder="5,10,15,20,25,30,35,40" value="<?php echo $percentage_options ? esc_attr( $percentage_options ): '5,10,15,20,25,30,35,40'; ?>" >
							<p><?php echo esc_html__( 'Add multiple percentage tip amount options separated by comma (,).', 'addify-tipping-at-cart-checkout' ); ?></p>
							<p><strong>Note: </strong><?php echo esc_html__( 'Percentage-based tipping are calculated based on the total cart amount.', 'addify-tipping-at-cart-checkout' ); ?></p>
						</td>
					</tr>

					<tr class="tipping_percentage_row_select" valign="top">
						<th scope="row"><?php echo esc_html__( 'Tipping templates:', 'addify-tipping-at-cart-checkout' ); ?></th>
						<td>
							<select name="af_tbw_tipping_or_donation_precentage_options">
								<option value="select_box" <?php selected( $af_tbw_tipping_or_donation_precentage_options, 'select_box' ); ?>><?php echo esc_html__( 'Select Box', 'addify-tipping-at-cart-checkout' ); ?></option>
								<option value="Buttons" <?php selected( $af_tbw_tipping_or_donation_precentage_options, 'Buttons' ); ?>><?php echo esc_html__( 'Buttons', 'addify-tipping-at-cart-checkout' ); ?></option>
								<option value="radio_btn" <?php selected( $af_tbw_tipping_or_donation_precentage_options, 'radio_btn' ); ?>><?php echo esc_html__( 'Radio Button', 'addify-tipping-at-cart-checkout' ); ?></option>
								<option value="popup" <?php selected( $af_tbw_tipping_or_donation_precentage_options, 'popup' ); ?>><?php echo esc_html__( 'Popup', 'addify-tipping-at-cart-checkout' ); ?></option>
							  
							</select>
							<p><?php echo esc_html__( 'Choose an appropriate template for tipping section.', 'addify-tipping-at-cart-checkout' ); ?></p>
						</td>
					</tr>
					
					<tr valign="top">
							<th scope="row"><?php echo esc_html__( 'Title for tipping fee in cart:', 'addify-tipping-at-cart-checkout' ); ?></th>
							<td>
							<input type="text" name="af_tipping_or_donation_summary_title" id="af_tipping_or_donation_summary_title" placeholder="Tip" value="<?php echo $af_tipping_or_donation_summary_title ? esc_attr( $af_tipping_or_donation_summary_title ): 'Tip'; ?>" required>
							<p><?php echo esc_html__( 'Choose an appropriate title that will appear on the cart and checkout pages to let customers know the selected tipping has been applied to their order totals.', 'addify-tipping-at-cart-checkout' ); ?></p>
							</td>
					</tr>
					<tr valign="top">
						<th scope="row"><?php echo esc_html__( 'Make tipping taxable:', 'addify-tipping-at-cart-checkout' ); ?></th>
						<td>
							<label for="af_tbw_enable_tipping_or_donation_taxable">
								<input type="checkbox" name="af_tbw_enable_tipping_or_donation_taxable" id="af_tbw_enable_tipping_or_donation_taxable" value="yes" 
								<?php
								checked(
									$af_tbw_enable_tipping_or_donation_taxable,
									'yes'
								);
								?>
																																											>
								<?php echo esc_html__( 'Yes', 'addify-tipping-at-cart-checkout' ); ?>
							</label>
							<p><?php echo esc_html__( 'Select this checkbox to make the tipping amount taxable.', 'addify-tipping-at-cart-checkout' ); ?></p>
						</td>
					</tr>
					<tr valign="top">
						<th scope="row"><?php echo esc_html__( 'Custom amount button title.', 'addify-tipping-at-cart-checkout' ); ?></th>
						<td>
							<?php $af_td_other_btn_text = get_option('af_td_other_btn_text'); ?>
							<input type="text" name="af_td_other_btn_text" id="af_td_other_btn_text" value="<?php echo $af_td_other_btn_text ? esc_attr($af_td_other_btn_text) : 'Other'; ?>">
							<p><?php echo esc_html__( 'Personalize button title used for adding custom tipping amount.', 'addify-tipping-at-cart-checkout' ); ?></p>
						</td>
					</tr>
					<tr valign="top">
						<th scope="row"><?php echo esc_html__( 'Custom amount input field placeholder for tipping:', 'addify-tipping-at-cart-checkout' ); ?></th>
						<td>
							<?php $af_td_other_field_place_holder = get_option('af_td_other_field_place_holder'); ?>
							<input type="text" name="af_td_other_field_place_holder" id="af_td_other_field_place_holder" value="<?php echo $af_td_other_field_place_holder ? esc_attr($af_td_other_field_place_holder) : 'Add amount'; ?>">
							<p><?php echo esc_html__( 'Add a custom placeholder for custom amount input field.', 'addify-tipping-at-cart-checkout' ); ?></p>
						</td>
					</tr>
					<tr valign="top">
						<th scope="row"><?php echo esc_html__( 'Tipping success message:', 'addify-tipping-at-cart-checkout' ); ?></th>
						<td>
							<?php $af_td_notice_message = get_option('af_td_notice_message'); ?>
							<input type="text" name="af_td_notice_message" id="af_td_notice_message" value="<?php echo $af_td_notice_message ? esc_attr($af_td_notice_message) : 'Tip has been successfully added to your order'; ?>">
							<p><?php echo esc_html__( 'Display a custom success message when a tipping is successfully applied to an order. You can use variable {price} to show the added amount in the success message.', 'addify-tipping-at-cart-checkout' ); ?></p>
						</td>
					</tr>
					<tr valign="top">
						<th scope="row"><?php echo esc_html__( 'Select user roles:', 'addify-tipping-at-cart-checkout' ); ?></th>
						<td>
							<?php
							global $wp_roles;
							$af_tipping_userrole = (array) get_option('af_tipping_or_donation_userrole');
							?>
							<select name="af_tipping_or_donation_userrole[]" id="af_tipping_or_donation_userrole" multiple>
								<?php foreach ( $wp_roles->roles as $key=>$value ) : ?>
								<option value="<?php echo esc_attr($key); ?>" <?php echo in_array($key, $af_tipping_userrole) ? 'selected' : ''; ?>><?php echo esc_html($value['name']); ?></option>
								<?php endforeach; ?>
								<option value="guest" <?php echo in_array('guest', $af_tipping_userrole) ? 'selected' : ''; ?>><?php echo esc_html__( 'Guest', 'addify-tipping-at-cart-checkout' ); ?></option>
							</select>
							<p><?php echo esc_html__( 'Show tipping section to selected user roles only. Leave empty to display for all customers.', 'addify-tipping-at-cart-checkout' ); ?></p>
						</td>
					</tr>
					<tr valign="top">
						<th scope="row"><?php echo esc_html__( 'Enable shortcode:', 'addify-tipping-at-cart-checkout' ); ?></th>
						<td>
							<?php
							$af_tbw_enable_tipping_or_donation_shortcode = get_option('af_tbw_enable_tipping_or_donation_shortcode');
							?>
							<input type="checkbox" name="af_tbw_enable_tipping_or_donation_shortcode" id="af_tbw_enable_tipping_or_donation_shortcode" value="yes" 
							<?php
							checked(
								$af_tbw_enable_tipping_or_donation_shortcode,
								'yes'
							);
							?>
							>
							<p class="adf-shortcode-enable"><code>[adf_tip_and_donation]</code></p>
							<p><?php echo esc_html__( 'Check to enable shortcode. Add this shortcode anywhere to display the tipping section for your customers.', 'addify-tipping-at-cart-checkout' ); ?></p>
						</td>
					</tr>
					<tr valign="top" class="adf-shortcode-enable">
						<th scope="row"><?php echo esc_html__( 'Tipping section heading:', 'addify-tipping-at-cart-checkout' ); ?></th>
						<td>
							<?php
							$af_tbw_enable_tipping_or_donation_text = get_option('af_tbw_enable_tipping_or_donation_text');
							?>
							<input type="text" name="af_tbw_enable_tipping_or_donation_text" id="af_tbw_enable_tipping_or_donation_text" value="<?php echo $af_tbw_enable_tipping_or_donation_text ? esc_attr($af_tbw_enable_tipping_or_donation_text): 'Tipping'; ?>">
							<p><?php echo esc_html__( 'Add a custom heading for shortcode-based tipping section.', 'addify-tipping-at-cart-checkout' ); ?></p>
						</td>
					</tr>
					<tr valign="top" class="adf-shortcode-enable">
						<th scope="row"><?php echo esc_html__( 'Tipping section description:', 'addify-tipping-at-cart-checkout' ); ?></th>
						<td>
							<?php
							$af_tbw_enable_tipping_or_donation_content = get_option('af_tbw_enable_tipping_or_donation_content');
							?>
							<textarea rows="5" name="af_tbw_enable_tipping_or_donation_content" id="af_tbw_enable_tipping_or_donation_content" value="<?php echo $af_tbw_enable_tipping_or_donation_content ? esc_attr($af_tbw_enable_tipping_or_donation_content):'Support us by donating'; ?>"><?php echo esc_textarea($af_tbw_enable_tipping_or_donation_content); ?></textarea>
							<p><?php echo esc_html__( 'Add description for shortcode based tipping section.', 'addify-tipping-at-cart-checkout' ); ?></p>
						</td>
					</tr>
				</table>
			  
			</div>
			<?php
		}
	}
	/**
	 * Af_tbw_restriction_content
	 */
	public function af_tbw_restriction_content() {
		if ( isset( $_POST['af_tbw_settings_nonce'] ) && ! empty( $_POST['af_tbw_settings_nonce'] ) ) {
			if ( ! check_admin_referer( 'af_tbw_tipping_donation_setting', 'af_tbw_settings_nonce' ) ) {
				// Nonce verification failed
				wp_die( 'Nonce verification failed. Please try again.' );
			}
		}
		$af_tbw_current_section = isset( $_GET['section'] ) ? sanitize_text_field( wp_unslash( $_GET['section'] ) ) : 'settings';

		if ( 'restriction' === $af_tbw_current_section ) {

			$af_tbw_products_tipping_or_donation_restriction_product_ids         = get_option( 'af_tbw_products_tipping_or_donation_restriction_product_ids' );
			$af_tbw_categories_tipping_donation_restriction_category_ids         = get_option( 'af_tbw_categories_tipping_donation_restriction_category_ids' );
			$af_tbw_shipping_tipping_or_donation_restriction_shipping_method_ids = get_option( 'af_tbw_shipping_tipping_or_donation_restriction_shipping_method_ids' );
			wp_nonce_field( 'af_tbw_tipping_donation_restriction', 'af_tbw_restriction_nonce' );
			?>
		
			<h1><?php echo esc_html__( 'Restrictions', 'addify-tipping-at-cart-checkout' ); ?></h1>
			<table class="form-table">
				<tr valign="top">
					<th scope="row"><?php echo esc_html__( 'Products:', 'addify-tipping-at-cart-checkout' ); ?></th>
					<td>
					<label for="af_tbw_products_tipping_or_donation_restriction_product_ids">
					<select name="af_tbw_products_tipping_or_donation_restriction_product_ids[]" class="af_tbw_products_tipping_or_donation_restriction_product_ids" id="af_tbw_products_tipping_or_donation_restriction_product_ids" multiple>
	
			<?php
			foreach ( (array) $af_tbw_products_tipping_or_donation_restriction_product_ids  as $af_tbw_product_id ) {
				if ( $af_tbw_product_id ) {
					$af_tbw_product = wc_get_product( $af_tbw_product_id );
					if ( $af_tbw_product ) :
						?>
				<option value="<?php echo esc_attr( $af_tbw_product_id ); ?>" selected><?php echo esc_attr( $af_tbw_product->get_name() ); ?></option>
						<?php
				endif;
				}
			}
			?>
		</select>
		<p><?php echo esc_html__( 'Show the tip and donation section only when the cart contains any of the above-selected products. Leave it empty to show for all products.', 'addify-tipping-at-cart-checkout' ); ?></p>
				</td>
				</tr>
				<tr valign="top">
					<th scope="row"><?php echo esc_html__( 'Categories:', 'addify-tipping-at-cart-checkout' ); ?></th>
					<td>
					<select name="af_tbw_categories_tipping_donation_restriction_category_ids[]" class="af_tbw_categories_tipping_donation_restriction_category_ids" id="af_tbw_categories_tipping_donation_restriction_category_ids" multiple>
			<?php
			$categories = get_terms(
				array(
					'taxonomy'   => 'product_cat',
					'hide_empty' => false,
				)
			);

			if ( $categories && ! is_wp_error( $categories ) ) {
				foreach ( $categories as $category ) {
					?>
				<option value="<?php echo esc_attr( $category->term_id ); ?>" <?php selected( true, in_array( $category->term_id, (array) $af_tbw_categories_tipping_donation_restriction_category_ids ) ); ?>><?php echo esc_html( $category->name ); ?></option>
					<?php
				}
			}
			?>
		</select>
		<p><?php echo esc_html__( 'Show tip and donation section only when the cart contains a product from any of the above categories. Leave empty to show for all products.', 'addify-tipping-at-cart-checkout' ); ?></p>
					</td>
				</tr>
				<tr valign="top">
					<th scope="row"><?php echo esc_html__( 'Shipping methods:', 'addify-tipping-at-cart-checkout' ); ?></th>
					<td>
					<select name="af_tbw_shipping_tipping_or_donation_restriction_shipping_method_ids[]" class="af_tbw_shipping_tipping_or_donation_restriction_shipping_method_ids" id="af_tbw_shipping_tipping_or_donation_restriction_shipping_method_ids" multiple>
			<?php
			$zones = WC_Shipping_Zones::get_zones();

			foreach ( $zones as $zone ) {
				$shipping_methods = $zone['shipping_methods'];

				foreach ( $shipping_methods as $method ) {
					?>
				<option value="<?php echo esc_attr( $method->id ); ?>" <?php selected( true, in_array( $method->id, (array) $af_tbw_shipping_tipping_or_donation_restriction_shipping_method_ids ) ); ?>><?php echo esc_html( $method->title ); ?></option>
					<?php
				}
			}
			?>
		</select>
		<p><?php echo esc_html__( 'Select payment methods to show the tipping section only when any of the above payment methods is selected.', 'addify-tipping-at-cart-checkout' ); ?></p>
			</td>
			</tr>
			</table>
			<?php
		}
	}
	/**
	 * Af_tbw_style_content
	 */
	public function af_tbw_style_content() {
		if ( isset( $_POST['af_tbw_settings_nonce'] ) && ! empty( $_POST['af_tbw_settings_nonce'] ) ) {
			if ( ! check_admin_referer( 'af_tbw_tipping_donation_setting', 'af_tbw_settings_nonce' ) ) {
				// Nonce verification failed
				wp_die( 'Nonce verification failed. Please try again.' );
			}
		}

		$af_tbw_current_section = isset( $_GET['section'] ) ? sanitize_text_field( wp_unslash( $_GET['section'] ) ) : 'settings';

		if ( 'style' === $af_tbw_current_section ) {
			$af_tbw_element_border_radius    = get_option( 'af_tbw_element_border_radius', '0' );
			$af_tbw_element_color            = get_option( 'af_tbw_element_color', 'black' );
			$af_tbw_element_background_color = get_option( 'af_tbw_element_background_color', 'white' );
			$af_tbw_element_border           = get_option( 'af_tbw_element_border', '0' );
			$af_tbw_background_width         = get_option('af_tbw_background_width');
			$af_tbw_border_color             = get_option('af_tbw_border_color');
			$af_tbw_element_hover_color      = get_option('af_tbw_element_hover_color');
			$af_tbw_element_bg_hover_color   = get_option('af_tbw_element_bg_hover_color');
			?>
			<div class="wrap woocommerce">
				<h1><?php esc_html_e( 'Style', 'addify-tipping-at-cart-checkout' ); ?></h1>
				<table class="form-table">
					<?php
			$af_tbw_tipping_or_donation_precentage_options = get_option('af_tbw_tipping_or_donation_precentage_options');
					if ( 'Buttons' === $af_tbw_tipping_or_donation_precentage_options) {
						?>
			<tr valign="top">
				<th scope="row"><?php echo esc_html__( 'Tipping box width:', 'addify-tipping-at-cart-checkout' ); ?></th>
					<td>
					<input type="number" name="af_tbw_background_width" id="af_tbw_background_width" min="50" max="100" value="<?php echo $af_tbw_background_width ? esc_attr( $af_tbw_background_width ): '50'; ?>" >
					<p><?php echo esc_html__( 'Add width in percentage for tipping box. You can choose a value between 50-100% only.', 'addify-tipping-at-cart-checkout' ); ?></p>
				</td>
			</tr>
				<?php } ?>
			<tr valign="top">
				<th scope="row"><?php echo esc_html__( 'Tipping box text color:', 'addify-tipping-at-cart-checkout' ); ?></th>
					<td>
					<?php $af_tbw_box_text_color = get_option('af_tbw_box_text_color', '#fff'); ?>
					<input type="color" name="af_tbw_box_text_color" id="af_tbw_box_text_color" value="<?php echo esc_attr( $af_tbw_box_text_color ); ?>" >
					<p><?php echo esc_html__( 'Choose a text color for tipping box.', 'addify-tipping-at-cart-checkout' ); ?></p>
				</td>
			</tr>
			<tr valign="top">
				<th scope="row"><?php echo esc_html__( 'Tipping box background color:', 'addify-tipping-at-cart-checkout' ); ?></th>
					<td>
					<?php $af_tbw_box_background_color = get_option('af_tbw_box_background_color', '#fff'); ?>
					<input type="color" name="af_tbw_box_background_color" id="af_tbw_box_background_color" value="<?php echo esc_attr( $af_tbw_box_background_color ); ?>" >
					<p><?php echo esc_html__( 'Choose a background color for tipping box.', 'addify-tipping-at-cart-checkout' ); ?></p>
				</td>
			</tr>
			<tr valign="top">
				<th scope="row"><?php echo esc_html__( 'Tipping box border color:', 'addify-tipping-at-cart-checkout' ); ?></th>
					<td>
					<?php $af_tbw_box_border_color = get_option('af_tbw_box_border_color', '#000'); ?>
					<input type="color" name="af_tbw_box_border_color" id="af_tbw_box_border_color" value="<?php echo esc_attr( $af_tbw_box_border_color ); ?>" >
					<p><?php echo esc_html__( 'Choose a border color for tipping box.', 'addify-tipping-at-cart-checkout' ); ?></p>
				</td>
			</tr>
			<tr>
				<th><h3 style="margin: 0!important"><?php esc_html_e( 'Add tip button style', 'addify-tipping-at-cart-checkout' ); ?></h3></th>
			</tr>
			<tr valign="top">
				<th scope="row"><?php echo esc_html__( 'Add tip button text color:', 'addify-tipping-at-cart-checkout' ); ?></th>
					<td>
					<?php $af_tbw_button_text_color = get_option('af_tbw_button_text_color'); ?>
					<input type="color" name="af_tbw_button_text_color" id="af_tbw_button_text_color"   value="<?php echo esc_attr( $af_tbw_button_text_color ); ?>" >
					<p><?php echo esc_html__( 'Choose appropriate color for add tip button text.', 'addify-tipping-at-cart-checkout' ); ?></p>
				</td>
			</tr>
			<tr valign="top">
				<th scope="row"><?php echo esc_html__( 'Add tip button background color:', 'addify-tipping-at-cart-checkout' ); ?></th>
					<td>
					<?php $af_tbw_button_background_color = get_option('af_tbw_button_background_color'); ?>
					<input type="color" name="af_tbw_button_background_color" id="af_tbw_button_background_color"   value="<?php echo esc_attr( $af_tbw_button_background_color ); ?>" >
					<p><?php echo esc_html__( 'Choose appropriate color for add tip button background.', 'addify-tipping-at-cart-checkout' ); ?></p>
				</td>
			</tr>
			<tr valign="top">
				<th scope="row"><?php echo esc_html__( 'Add tip button border color:', 'addify-tipping-at-cart-checkout' ); ?></th>
				<td>
					<?php $af_tbw_button_border_color = get_option('af_tbw_button_border_color'); ?>
					<input type="color" name="af_tbw_button_border_color" id="af_tbw_button_border_color"   value="<?php echo esc_attr( $af_tbw_button_border_color ); ?>" >
					<p><?php echo esc_html__( 'Choose appropriate color for add tip button border.', 'addify-tipping-at-cart-checkout' ); ?></p>
				</td>
			</tr>
			<tr valign="top">
				<th scope="row"><?php echo esc_html__( 'Add tip button text hover color:', 'addify-tipping-at-cart-checkout' ); ?></th>
					<td>
					<?php $af_tbw_button_hover_color = get_option('af_tbw_button_hover_color'); ?>
					<input type="color" name="af_tbw_button_hover_color" id="af_tbw_button_hover_color"   value="<?php echo esc_attr( $af_tbw_button_hover_color ); ?>" >
					<p><?php echo esc_html__( 'Choose appropriate color for add tip button text on hover.', 'addify-tipping-at-cart-checkout' ); ?></p>
				</td>
			</tr>
			<tr valign="top">
				<th scope="row"><?php echo esc_html__( 'Add tip button background on hover color:', 'addify-tipping-at-cart-checkout' ); ?></th>
					<td>
					<?php $af_tbw_button_hover_bg_color = get_option('af_tbw_button_hover_bg_color'); ?>
					<input type="color" name="af_tbw_button_hover_bg_color" id="af_tbw_button_hover_bg_color"   value="<?php echo esc_attr( $af_tbw_button_hover_bg_color ); ?>" >
					<p><?php echo esc_html__( 'Choose appropriate color for add tip button background on hover.', 'addify-tipping-at-cart-checkout' ); ?></p>
				</td>
			</tr>
			<tr valign="top">
				<th scope="row"><?php echo esc_html__( 'Add tip button border size:', 'addify-tipping-at-cart-checkout' ); ?></th>
				<td>
						<?php $af_tbw_button_border = get_option('af_tbw_button_border'); ?>
					<input type="number" name="af_tbw_button_border" id="af_tbw_button_border" min="0" max="10" value="<?php echo esc_attr( $af_tbw_button_border ); ?>" >
					<p><?php echo esc_html__( 'Add "add tip button" border in px.', 'addify-tipping-at-cart-checkout' ); ?></p>
				</td>
			</tr>
			<tr valign="top">
				<th scope="row"><?php echo esc_html__( 'Add tip button border radius:', 'addify-tipping-at-cart-checkout' ); ?></th>
				<td>
					<?php $af_tbw_button_border_radius = get_option('af_tbw_button_border_radius'); ?>
					<input type="number" name="af_tbw_button_border_radius" id="af_tbw_button_border_radius" min="0" max="30" value="<?php echo esc_attr( $af_tbw_button_border_radius ); ?>">
					<p><?php echo esc_html__( 'Add "add tip button" radius in px.', 'addify-tipping-at-cart-checkout' ); ?></p>
				</td>
			</tr>
			<tr>
				<th><h3 style="margin: 0!important"><?php esc_html_e( 'Options style', 'addify-tipping-at-cart-checkout' ); ?></h3></th>
			</tr>
			<?php
			$af_tbw_tipping_or_donation_precentage_options = get_option('af_tbw_tipping_or_donation_precentage_options');
			if ( 'radio_btn' === $af_tbw_tipping_or_donation_precentage_options) {
				?>
			<tr valign="top">
				<th scope="row"><?php echo esc_html__( 'Option text color:', 'addify-tipping-at-cart-checkout' ); ?></th>
				<td>
					<?php $af_tbw_element_radio_btn_color = get_option('af_tbw_element_radio_btn_color'); ?>
					<input type="color" name="af_tbw_element_radio_btn_color" id="af_tbw_element_radio_btn_color"   value="<?php echo esc_attr( $af_tbw_element_radio_btn_color ); ?>" >
					<p><?php echo esc_html__( 'Choose appropriate color for option text.', 'addify-tipping-at-cart-checkout' ); ?></p>
				</td>
			</tr>
			<?php } else { ?>
			<tr valign="top">
				<th scope="row"><?php echo esc_html__( 'Option text color:', 'addify-tipping-at-cart-checkout' ); ?></th>
					<td>
					<input type="color" name="af_tbw_element_color" id="af_tbw_element_color"   value="<?php echo esc_attr( $af_tbw_element_color ); ?>" >
					<p><?php echo esc_html__( 'Choose appropriate color for option text.', 'addify-tipping-at-cart-checkout' ); ?></p>
				</td>
			</tr>
			<tr valign="top">
				<th scope="row"><?php echo esc_html__( 'Option background color:', 'addify-tipping-at-cart-checkout' ); ?></th>
					<td>
					<input type="color" name="af_tbw_element_background_color" id="af_tbw_element_background_color"   value="<?php echo esc_attr( $af_tbw_element_background_color ); ?>" >
					<p><?php echo esc_html__( 'Choose appropriate color for option.', 'addify-tipping-at-cart-checkout' ); ?></p>
				</td>
			</tr>
			<tr valign="top">
				<th scope="row"><?php echo esc_html__( 'Option border color:', 'addify-tipping-at-cart-checkout' ); ?></th>
					<td>
					<input type="color" name="af_tbw_border_color" id="af_tbw_border_color"   value="<?php echo esc_attr( $af_tbw_border_color ); ?>" >
					<p><?php echo esc_html__( 'Choose appropriate color for option border.', 'addify-tipping-at-cart-checkout' ); ?></p>
				</td>
			</tr>
			<?php } ?>
			<tr valign="top">
				<th scope="row"><?php echo esc_html__( 'Option text hover color:', 'addify-tipping-at-cart-checkout' ); ?></th>
					<td>
					<input type="color" name="af_tbw_element_hover_color" id="af_tbw_element_hover_color" value="<?php echo $af_tbw_element_hover_color ? esc_attr( $af_tbw_element_hover_color ) : '#fff'; ?>" >
					<p><?php echo esc_html__( 'Choose appropriate color for option text on hover.', 'addify-tipping-at-cart-checkout' ); ?></p>
				</td>
			</tr>
			<?php
			$af_tbw_tipping_or_donation_precentage_options = get_option('af_tbw_tipping_or_donation_precentage_options');
			if ( 'radio_btn' !== $af_tbw_tipping_or_donation_precentage_options ) {
				?>
			<tr valign="top">
				<th scope="row"><?php echo esc_html__( 'Option background on hover color:', 'addify-tipping-at-cart-checkout' ); ?></th>
					<td>
					<input type="color" name="af_tbw_element_bg_hover_color" id="af_tbw_element_bg_hover_color"   value="<?php echo $af_tbw_element_bg_hover_color ? esc_attr( $af_tbw_element_bg_hover_color ) : '#5f5959'; ?>" >
					<p><?php echo esc_html__( 'Choose appropriate color for option background on hover.', 'addify-tipping-at-cart-checkout' ); ?></p>
				</td>
			</tr>
			<tr valign="top">
				<th scope="row"><?php echo esc_html__( 'Option border size:', 'addify-tipping-at-cart-checkout' ); ?></th>
					<td>
					<input type="number" name="af_tbw_element_border" id="af_tbw_element_border" min="0" max="10" value="<?php echo esc_attr( $af_tbw_element_border ); ?>" >
					<p><?php echo esc_html__( 'Add option border in px.', 'addify-tipping-at-cart-checkout' ); ?></p>
				</td>
			</tr>
			<tr valign="top">
				<th scope="row"><?php echo esc_html__( 'Option border radius:', 'addify-tipping-at-cart-checkout' ); ?></th>
					<td>
					<input type="number" name="af_tbw_element_border_radius" id="af_tbw_element_border_radius" min="0" max="30" value="<?php echo esc_attr( $af_tbw_element_border_radius ); ?>">
					<p><?php echo esc_html__( 'Add option radius in px.', 'addify-tipping-at-cart-checkout' ); ?></p>
				</td>
			</tr>
			<?php } ?>
			<tr valign="top">
				<th scope="row"><?php echo esc_html__( 'Custom CSS:', 'addify-tipping-at-cart-checkout' ); ?></th>
					<td>
					<?php $af_tbw_custom_css = get_option('af_tbw_custom_css'); ?>

					<textarea name="af_tbw_custom_css" id="af_tbw_custom_css" rows="6" value="<?php echo esc_attr( $af_tbw_custom_css ); ?>"><?php echo esc_attr( $af_tbw_custom_css ); ?></textarea>
					<p><?php echo esc_html__( 'Add custom css to style tipping section as you like.', 'addify-tipping-at-cart-checkout' ); ?></p>
				</td>
			</tr>
			</table>
			</div>
			<?php
		}
	}
	/**
	 * Af_tbw_report_content
	 */
	public function af_tbw_report_content() {

		if ( isset( $_POST['af_tbw_settings_nonce'] ) && ! empty( $_POST['af_tbw_settings_nonce'] ) ) {
			if ( ! check_admin_referer( 'af_tbw_tipping_donation_setting', 'af_tbw_settings_nonce' ) ) {
				// Nonce verification failed
				wp_die( 'Nonce verification failed. Please try again.' );
			}
		}

		$af_tbw_current_section = isset( $_GET['section'] ) ? sanitize_text_field( wp_unslash( $_GET['section'] ) ) : 'settings';
		$paged                  = isset( $_GET['paged'] ) ? sanitize_text_field( wp_unslash( $_GET['paged'] ) ) : 1;

		if ( 'report' === $af_tbw_current_section ) {

				$args = array(
					'post_type'      => 'donation_total',
					'posts_per_page' => 10,
					'fields'         => 'ids',
					'paged'          => $paged,
					'order'          => 'DSC',
				);

				$donation_totals             = new WP_Query( $args );
				$af_order_report_page_output = '';

				if ( $donation_totals->posts ) {

					?>
			<table class="wp-list-table widefat striped">
			<thead><tr>
			<th><?php echo esc_html( __( 'Order ID', 'addify-tipping-at-cart-checkout' ) ); ?></th>
			<th><?php echo esc_html( __( 'Date', 'addify-tipping-at-cart-checkout' ) ); ?></th>
			<th><?php echo esc_html( __( 'Tipping/Donation Total', 'addify-tipping-at-cart-checkout' ) ); ?></th>
			</tr></thead>
			<tbody>
					<?php
					$total_tipping_donations = 0;
					foreach ( $donation_totals->posts as $post_id ) {
						$tipping_donation_total   = get_post_meta( $post_id, 'tipping_donation_total', true );
						$total_tipping_donations += floatval( $tipping_donation_total )
						?>
					<tr>
					<td>
						<a class="fa fa-eye" target="_blank" href="<?php echo esc_url( get_edit_post_link( get_post_meta( $post_id, 'order_id', true ) ) ); ?>">
							<?php echo esc_attr( get_post_meta( $post_id, 'order_id', true ) ); ?>
						</a>	
					</td>
					<td><?php echo esc_html( get_the_date( '', $post_id ) ); ?></td>
					<td> <?php echo wp_kses_post( wc_price( get_post_meta( $post_id, 'tipping_donation_total', true ) ) ); ?> </td>
					
				</tr>
						<?php
					}
					?>
			</tbody>
			<tfoot>
				<tr>
					<th colspan="2"><strong>Grand Total</strong></th>
					<td><strong><?php echo wp_kses_post( wc_price( $total_tipping_donations ) ); ?></strong></td>
				</tr>
			</tfoot>
			</table>
					<?php
					$pagination = paginate_links(
						array(
							'total'     => $donation_totals->max_num_pages,
							'current'   => $paged,
							'prev_text' => __( '&laquo; Previous', 'addify-tipping-at-cart-checkout' ),
							'next_text' => __( 'Next &raquo;', 'addify-tipping-at-cart-checkout' ),
							'base'      => add_query_arg( 'paged', '%#%' ),
							'format'    => '',
						)
					);

					?>
			<div class="pagination">
				<?php
					if (!empty($pagination)) {
						echo wp_kses_post( $pagination );
					}
					?>
			</div>
					<?php
				} else {
					echo esc_html( 'No donation totals found.' );
				}
		}
	}
	/**
	 * Af_tbw_save_settings
	 */
	public function af_tbw_save_settings() {

		$af_tbw_current_section = isset( $_GET['section'] ) ? sanitize_text_field( wp_unslash( $_GET['section'] ) ) : 'settings';

		$af_tbw_settings_nonce = isset( $_POST['af_tbw_settings_nonce'] ) ? sanitize_text_field( wp_unslash( $_POST['af_tbw_settings_nonce'] ) ) : '';

		if ( ! wp_verify_nonce( $af_tbw_settings_nonce, 'af_tbw_tipping_donation_setting' ) ) {
			wp_die( esc_html__( 'Security Failed!', 'addify-tipping-at-cart-checkout' ) );
		}

		if ( 'settings' === $af_tbw_current_section ) {

				$enable_tipping_or_donation = isset( $_POST['af_tbw_enable_tipping_or_donation'] ) ? 'yes' : 'no';
				update_option( 'af_tbw_enable_tipping_or_donation', $enable_tipping_or_donation );
				$tipping_or_donation_option = isset( $_POST['af_tbw_tipping_or_donation_type'] ) ? sanitize_text_field( wp_unslash( $_POST['af_tbw_tipping_or_donation_type'] ) ) : 'fixed';
				update_option( 'af_tbw_tipping_or_donation_type', $tipping_or_donation_option );
				$af_tbw_tipping_or_donation_precentage_options = isset( $_POST['af_tbw_tipping_or_donation_precentage_options'] ) ? sanitize_text_field( wp_unslash( $_POST['af_tbw_tipping_or_donation_precentage_options'] ) ) : 'select_box';
				update_option( 'af_tbw_tipping_or_donation_precentage_options', $af_tbw_tipping_or_donation_precentage_options );
				$percentage_options = isset( $_POST['af_tbw_percentage_predefiend_values'] ) ? sanitize_text_field( wp_unslash( $_POST['af_tbw_percentage_predefiend_values'] ) ) : '';
				update_option( 'af_tbw_percentage_predefiend_values', $percentage_options );
				$fixed_placeholder = isset( $_POST['af_tbw_fixed_placeholder'] ) ? sanitize_text_field( wp_unslash( $_POST['af_tbw_fixed_placeholder'] ) ) : '';
				update_option( 'af_tbw_fixed_placeholder', $fixed_placeholder );
				$af_tbw_tipping_or_donation_feilds = isset( $_POST['af_tbw_tipping_or_donation_feilds'] ) ? sanitize_text_field( wp_unslash( $_POST['af_tbw_tipping_or_donation_feilds'] ) ) : 'Both Cart and Checkout';
				update_option( 'af_tbw_tipping_or_donation_feilds', $af_tbw_tipping_or_donation_feilds );
				$af_tbw_tipping_or_donation_on_cart_page_display_option = isset( $_POST['af_tbw_tipping_or_donation_on_cart_page_display_option'] ) ? sanitize_text_field( wp_unslash( $_POST['af_tbw_tipping_or_donation_on_cart_page_display_option'] ) ) : 'before cart table';
				update_option( 'af_tbw_tipping_or_donation_on_cart_page_display_option', $af_tbw_tipping_or_donation_on_cart_page_display_option );
				$af_tbw_tipping_or_donation_on_checkout_page_display_option = isset( $_POST['af_tbw_tipping_or_donation_on_checkout_page_display_option'] ) ? sanitize_text_field( wp_unslash( $_POST['af_tbw_tipping_or_donation_on_checkout_page_display_option'] ) ) : 'before checkout form';
				update_option( 'af_tbw_tipping_or_donation_on_checkout_page_display_option', $af_tbw_tipping_or_donation_on_checkout_page_display_option );
				$af_tbw_tipping_or_donation_button_text = isset( $_POST['af_tbw_tipping_or_donation_button_text'] ) ? sanitize_text_field( wp_unslash( $_POST['af_tbw_tipping_or_donation_button_text'] ) ) : '';
				update_option( 'af_tbw_tipping_or_donation_button_text', $af_tbw_tipping_or_donation_button_text );
				$af_tbw_tipping_or_donation_message_text = isset( $_POST['af_tbw_tipping_or_donation_message_text'] ) ? wp_kses_post( wp_unslash( $_POST['af_tbw_tipping_or_donation_message_text'] ) ) : '';
				update_option( 'af_tbw_tipping_or_donation_message_text', $af_tbw_tipping_or_donation_message_text );
				$af_tbw_tipping_or_donation_heading_text = isset( $_POST['af_tbw_tipping_or_donation_heading_text'] ) ? sanitize_text_field( wp_unslash( $_POST['af_tbw_tipping_or_donation_heading_text'] ) ) : '';
				update_option( 'af_tbw_tipping_or_donation_heading_text', $af_tbw_tipping_or_donation_heading_text );
				
				$af_tipping_or_donation_summary_title = isset( $_POST['af_tipping_or_donation_summary_title'] ) ? sanitize_text_field( wp_unslash( $_POST['af_tipping_or_donation_summary_title'] ) ) : '';
				update_option( 'af_tipping_or_donation_summary_title', $af_tipping_or_donation_summary_title );
				$af_tbw_enable_tipping_or_donation_taxable = isset( $_POST['af_tbw_enable_tipping_or_donation_taxable'] ) ? 'yes' : 'no';
				update_option( 'af_tbw_enable_tipping_or_donation_taxable', $af_tbw_enable_tipping_or_donation_taxable );
				$af_tipping_or_donation_userrole = isset( $_POST['af_tipping_or_donation_userrole'] ) ? (array) array_map( 'sanitize_text_field', wp_unslash( $_POST['af_tipping_or_donation_userrole'] ) ) : array();
				update_option( 'af_tipping_or_donation_userrole', $af_tipping_or_donation_userrole );
				$af_td_other_btn_text = isset( $_POST['af_td_other_btn_text'] ) ? sanitize_text_field( wp_unslash( $_POST['af_td_other_btn_text'] ) ) : 'Other';
				update_option( 'af_td_other_btn_text', $af_td_other_btn_text );
				$af_td_other_field_place_holder = isset( $_POST['af_td_other_field_place_holder'] ) ? sanitize_text_field( wp_unslash( $_POST['af_td_other_field_place_holder'] ) ) : 'Add amount';
				update_option( 'af_td_other_field_place_holder', $af_td_other_field_place_holder );
				
				$af_td_notice_message = isset( $_POST['af_td_notice_message'] ) ? sanitize_text_field( wp_unslash( $_POST['af_td_notice_message'] ) ) : 'sucessfully';
				update_option( 'af_td_notice_message', $af_td_notice_message );
				
				$af_tbw_enable_tipping_or_donation_shortcode = isset( $_POST['af_tbw_enable_tipping_or_donation_shortcode'] ) ? 'yes' : 'no';
				update_option( 'af_tbw_enable_tipping_or_donation_shortcode', $af_tbw_enable_tipping_or_donation_shortcode );
				$af_tbw_enable_tipping_or_donation_text = isset( $_POST['af_tbw_enable_tipping_or_donation_text'] ) ? sanitize_text_field( wp_unslash( $_POST['af_tbw_enable_tipping_or_donation_text'] ) ) : '';
				update_option( 'af_tbw_enable_tipping_or_donation_text', $af_tbw_enable_tipping_or_donation_text );
				$af_tbw_enable_tipping_or_donation_content = isset( $_POST['af_tbw_enable_tipping_or_donation_content'] ) ? sanitize_text_field( wp_unslash( $_POST['af_tbw_enable_tipping_or_donation_content'] ) ) : '';
				update_option( 'af_tbw_enable_tipping_or_donation_content', $af_tbw_enable_tipping_or_donation_content );

		} elseif ( 'restriction' === $af_tbw_current_section ) {

			$af_tbw_products_tipping_or_donation_restriction_product_ids = isset( $_POST['af_tbw_products_tipping_or_donation_restriction_product_ids'] ) ? (array) array_map( 'sanitize_text_field', wp_unslash( $_POST['af_tbw_products_tipping_or_donation_restriction_product_ids'] ) ) : array();
			update_option( 'af_tbw_products_tipping_or_donation_restriction_product_ids', $af_tbw_products_tipping_or_donation_restriction_product_ids );
			$af_tbw_categories_tipping_donation_restriction_category_ids = isset( $_POST['af_tbw_categories_tipping_donation_restriction_category_ids'] ) ? (array) array_map( 'sanitize_text_field', wp_unslash( $_POST['af_tbw_categories_tipping_donation_restriction_category_ids'] ) ) : array();
			update_option( 'af_tbw_categories_tipping_donation_restriction_category_ids', $af_tbw_categories_tipping_donation_restriction_category_ids );
			$af_tbw_shipping_tipping_or_donation_restriction_shipping_method_ids = isset( $_POST['af_tbw_shipping_tipping_or_donation_restriction_shipping_method_ids'] ) ? (array) array_map( 'sanitize_text_field', wp_unslash( $_POST['af_tbw_shipping_tipping_or_donation_restriction_shipping_method_ids'] ) ) : array();
			update_option( 'af_tbw_shipping_tipping_or_donation_restriction_shipping_method_ids', $af_tbw_shipping_tipping_or_donation_restriction_shipping_method_ids );

		} elseif ( 'style' === $af_tbw_current_section ) {
			$af_tbw_element_border_radius = isset( $_POST['af_tbw_element_border_radius'] ) ? sanitize_text_field( wp_unslash( $_POST['af_tbw_element_border_radius'] ) ) : '0';
			update_option( 'af_tbw_element_border_radius', $af_tbw_element_border_radius );
			$af_tbw_background_width = isset( $_POST['af_tbw_background_width'] ) ? sanitize_text_field( wp_unslash( $_POST['af_tbw_background_width'] ) ) : '50';
			update_option( 'af_tbw_background_width', $af_tbw_background_width );
			$af_tbw_box_background_color = isset( $_POST['af_tbw_box_background_color'] ) ? sanitize_text_field( wp_unslash( $_POST['af_tbw_box_background_color'] ) ) : '#fff';
			update_option( 'af_tbw_box_background_color', $af_tbw_box_background_color );
			$af_tbw_box_text_color = isset( $_POST['af_tbw_box_text_color'] ) ? sanitize_text_field( wp_unslash( $_POST['af_tbw_box_text_color'] ) ) : '#000';
			update_option( 'af_tbw_box_text_color', $af_tbw_box_text_color );
			$af_tbw_box_border_color = isset( $_POST['af_tbw_box_border_color'] ) ? sanitize_text_field( wp_unslash( $_POST['af_tbw_box_border_color'] ) ) : 'black';
			update_option( 'af_tbw_box_border_color', $af_tbw_box_border_color );
			$af_tbw_element_color = isset( $_POST['af_tbw_element_color'] ) ? sanitize_text_field( wp_unslash( $_POST['af_tbw_element_color'] ) ) : 'black';
			update_option( 'af_tbw_element_color', $af_tbw_element_color );
			$af_tbw_element_radio_btn_color = isset( $_POST['af_tbw_element_radio_btn_color'] ) ? sanitize_text_field( wp_unslash( $_POST['af_tbw_element_radio_btn_color'] ) ) : 'black';
			update_option( 'af_tbw_element_radio_btn_color', $af_tbw_element_radio_btn_color );
			$af_tbw_button_text_color = isset( $_POST['af_tbw_button_text_color'] ) ? sanitize_text_field( wp_unslash( $_POST['af_tbw_button_text_color'] ) ) : '#fff';
			update_option( 'af_tbw_button_text_color', $af_tbw_button_text_color );
			$af_tbw_element_bg_hover_color = isset( $_POST['af_tbw_element_bg_hover_color'] ) ? sanitize_text_field( wp_unslash( $_POST['af_tbw_element_bg_hover_color'] ) ) : '';
			update_option( 'af_tbw_element_bg_hover_color', $af_tbw_element_bg_hover_color );
			$af_tbw_element_hover_color = isset( $_POST['af_tbw_element_hover_color'] ) ? sanitize_text_field( wp_unslash( $_POST['af_tbw_element_hover_color'] ) ) : '';
			update_option( 'af_tbw_element_hover_color', $af_tbw_element_hover_color );
			$af_tbw_button_border_color = isset( $_POST['af_tbw_button_border_color'] ) ? sanitize_text_field( wp_unslash( $_POST['af_tbw_button_border_color'] ) ) : '#000';
			update_option( 'af_tbw_button_border_color', $af_tbw_button_border_color );
			$af_tbw_button_background_color = isset( $_POST['af_tbw_button_background_color'] ) ? sanitize_text_field( wp_unslash( $_POST['af_tbw_button_background_color'] ) ) : '#000';
			update_option( 'af_tbw_button_background_color', $af_tbw_button_background_color );
			$af_tbw_button_border = isset( $_POST['af_tbw_button_border'] ) ? sanitize_text_field( wp_unslash( $_POST['af_tbw_button_border'] ) ) : '0';
			update_option( 'af_tbw_button_border', $af_tbw_button_border );
			$af_tbw_button_hover_color = isset( $_POST['af_tbw_button_hover_color'] ) ? sanitize_text_field( wp_unslash( $_POST['af_tbw_button_hover_color'] ) ) : '#000';
			update_option( 'af_tbw_button_hover_color', $af_tbw_button_hover_color );
			$af_tbw_button_hover_bg_color = isset( $_POST['af_tbw_button_hover_bg_color'] ) ? sanitize_text_field( wp_unslash( $_POST['af_tbw_button_hover_bg_color'] ) ) : '#000';
			update_option( 'af_tbw_button_hover_bg_color', $af_tbw_button_hover_bg_color );
			$af_tbw_element_background_color = isset( $_POST['af_tbw_element_background_color'] ) ? sanitize_text_field( wp_unslash( $_POST['af_tbw_element_background_color'] ) ) : 'white';
			update_option( 'af_tbw_element_background_color', $af_tbw_element_background_color );
			$af_tbw_border_color = isset( $_POST['af_tbw_border_color'] ) ? sanitize_text_field( wp_unslash( $_POST['af_tbw_border_color'] ) ) : '#000';
			update_option( 'af_tbw_border_color', $af_tbw_border_color );
			$af_tbw_element_border = isset( $_POST['af_tbw_element_border'] ) ? sanitize_text_field( wp_unslash( $_POST['af_tbw_element_border'] ) ) : '0';
			update_option( 'af_tbw_element_border', $af_tbw_element_border );
			$af_tbw_button_border_radius = isset( $_POST['af_tbw_button_border_radius'] ) ? sanitize_text_field( wp_unslash( $_POST['af_tbw_button_border_radius'] ) ) : '0';
			update_option( 'af_tbw_button_border_radius', $af_tbw_button_border_radius );
			$af_tbw_custom_css = isset( $_POST['af_tbw_custom_css'] ) ? wp_kses_post( wp_unslash( $_POST['af_tbw_custom_css'] ) ) : '';
			update_option( 'af_tbw_custom_css', $af_tbw_custom_css );
		}
	} 
	/**
	 * Af_tbw_product_disp
	 */
	public function af_tbw_product_disp() {

		$af_tbw_nonce = isset( $_POST['nonce'] ) ? sanitize_text_field( wp_unslash( $_POST['nonce'] ) ) : '';

		if ( ! wp_verify_nonce( $af_tbw_nonce, 'af_tbw_nonce' ) ) {
			wp_send_json_error( 'Security Failed!' );
			exit;
		}

		if ( isset( $_POST['q'] ) && '' !== $_POST['q'] ) {
			$query = sanitize_text_field( wp_unslash( $_POST['q'] ) );
		} else {
			$query = '';
		}

		$data_array = array();

		$args = array(
			'post_type'   => 'product',
			'post_status' => 'publish',
			'numberposts' => 100,
			's'           => $query,
		);

		$products_query = wc_get_products( $args );

		foreach ( $products_query as $key => $products_obj ) {

			$product_id    = $products_obj->get_id();
			$product_title = $products_obj->get_name();

			$data_array[] = array( $product_id, $product_title );
		}

		echo wp_json_encode( $data_array );
		die();
	}
	/**
	 * Af_tbw_admin_enqueue_scripts
	 */
	public function af_tbw_admin_enqueue_scripts() {

		$curr_screen = get_current_screen();

		if ('woocommerce_page_wc-settings' == $curr_screen->id) {

			wp_enqueue_style( 'af_tbw_css', AF_T_B_W_PLUGIN_URL . 'assets/css/admin.css', array(), '1.0.0', 'all' );
			wp_enqueue_style( 'af_tbw_font_awesome', AF_T_B_W_PLUGIN_URL . 'assets/font-awesome/css/font-awesome.min.css', array(), '4.7.0' );
			wp_enqueue_style( 'select2-css', plugins_url( 'assets/css/select2.css', WC_PLUGIN_FILE ), array(), '5.7.2' );
			wp_enqueue_script( 'select2-js', plugins_url( 'assets/js/select2/select2.min.js', WC_PLUGIN_FILE ), array( 'jquery' ), '4.0.3', true );
			wp_enqueue_script( 'af_tbw_tipping_or_donation_js', AF_T_B_W_PLUGIN_URL . 'assets/js/admin.js', array( 'jquery' ), '1.0.0', false );

			wp_localize_script(
				'af_tbw_tipping_or_donation_js',
				'af_tbw_ajax_obj',
				array(
					'ajax_url' => admin_url( 'admin-ajax.php' ),
					'nonce'    => wp_create_nonce( 'af_tbw_nonce' ),
				)
			);
		}
	}
}



new AF_Woo_Tipping_Or_Donation_Admin();

