<?php
/**
 * File containing the _tipping_donation_Front class.
 *
 * @package addify-tipping-at-cart-checkout
 */

if ( ! defined( 'ABSPATH' ) ) {
	die;
}
		/**
		 * Af_Tbw_Ajax_Controller.
		 */
class Af_Tbw_Ajax_Controller {

		/**
		 * Constructer.
		 */
	public function __construct() {
		add_action( 'wp_ajax_af_tbw_get_tipping_donation_data', array( $this, 'af_tbw_get_tipping_donation_data' ) );
		add_action( 'wp_ajax_nopriv_af_tbw_get_tipping_donation_data', array( $this, 'af_tbw_get_tipping_donation_data' ) );
		add_action( 'wp_ajax_af_tbw_remove_tipping_donation_data', array( $this, 'af_tbw_remove_tipping_donation_data' ) );
		add_action( 'wp_ajax_nopriv_af_tbw_remove_tipping_donation_data', array( $this, 'af_tbw_remove_tipping_donation_data' ) );
	}

		/**
		 * Af_tbw_remove_tipping_donation_data.
		 */
	public function af_tbw_remove_tipping_donation_data() {

		$af_tbw_nonce = isset( $_POST['nonce'] ) ? sanitize_text_field( wp_unslash( $_POST['nonce'] ) ) : '';

		if ( ! wp_verify_nonce( $af_tbw_nonce, 'af_tbw_nonce' ) ) {
			wp_send_json_error( 'Security Failed!' );
			exit;
		}

		WC()->session->set( 'af_tbw_tipping_detail', 0 );
		WC()->session->set( 'af_tbw_tipping_donation_percentage', 0 );
		WC()->session->set( 'af_tbw_tipping_donation_fixed', 0 );

		$response = array(
			'message' => 'Response genrated Successfully!',
		);

		wp_send_json_success( $response );
	}
		/**
		 * Af_tbw_get_tipping_donation_data.
		 */
	public function af_tbw_get_tipping_donation_data() {
		// $af_subtotal=wc()->cart->get_subtotal();
		$af_tbw_nonce = isset( $_POST['nonce'] ) ? sanitize_text_field( wp_unslash( $_POST['nonce'] ) ) : '';

		if ( ! wp_verify_nonce( $af_tbw_nonce, 'af_tbw_nonce' ) ) {
			wp_send_json_error( 'Security Failed!' );
			exit;
		}
		$af_tbw_data_precentage = isset( $_POST['af_tbw_data_precentage'] ) ? sanitize_text_field( wp_unslash( $_POST['af_tbw_data_precentage'] ) ) : '';
		$af_tbw_data_fixed      = isset( $_POST['af_tbw_data_fixed'] ) ? sanitize_text_field( wp_unslash( $_POST['af_tbw_data_fixed'] ) ) : '';

		$type         = isset( $_POST['type'] ) ? sanitize_text_field( wp_unslash( $_POST['type'] ) ) : '';
		$custom_value = isset( $_POST['custom_value'] ) ? sanitize_text_field( wp_unslash( $_POST['custom_value'] ) ) : '';
		WC()->session->set(
			'af_tbw_tipping_detail',
			array(
				'type'         => $type,
				'custom_value' => $custom_value,
			)
		);

		if ( $af_tbw_data_precentage > 0 ) {
			WC()->session->set( 'af_tbw_tipping_donation_percentage', $af_tbw_data_precentage );
		}

		if ( $af_tbw_data_fixed > 0 ) {
			WC()->session->set( 'af_tbw_tipping_donation_fixed', $af_tbw_data_fixed );
		}
		if ( !empty($af_tbw_data_precentage) ) {
			if ( WC()->cart && ! WC()->cart->is_empty() ) {
				$af_tbw_subtotal_cart = WC()->cart->get_subtotal();
				$current_price        = $af_tbw_subtotal_cart * ( $af_tbw_data_precentage / 100 );
			}
		} else {
			$current_price = $af_tbw_data_fixed;
		}
		$formatted_price = $current_price ? wc_price( $current_price ):'';
		$notice_message  = get_option('af_td_notice_message');
		$final_message   = str_replace('{price}', $formatted_price, $notice_message);
		WC()->session->set( 'af_tbw_message', $final_message );
		$response = array(
			'message' => $final_message,
		);
		wp_send_json_success( $response );
	}
}

new Af_Tbw_Ajax_Controller();
