<?php
/**
 * File containing the Ka_Wss_tipping_donation_Front class.
 *
 * @package addify-tipping-at-cart-checkout
 */

if ( ! defined( 'ABSPATH' ) ) {
	die;
}


/**
 * Class af_Wss_tipping_donation_Front
 */
class Af_Woo_Tipping_Or_Donation_Front {
	/**
	 * Class constructor.
	 */
	public function __construct() {

		add_action( 'wp_loaded', array( $this, 'af_tbw_init' ) );
		add_action( 'woocommerce_checkout_update_order_meta', array( $this, 'af_tbw_save_tipping_donation_in_reports_table' ), 10, 1 );
		add_action( 'woocommerce_before_calculate_totals', array( $this, 'af_tbw_tip_donate_calculation' ) );
		add_filter( 'woocommerce_cart_totals_fee_html', array( $this, 'af_modify_donation_fee_amount_display' ), 10, 2 );
		add_action( 'wp_enqueue_scripts', array( $this, 'af_tbw_wp_tipping_enqueue_scripts' ) );
		add_shortcode( 'adf_tip_and_donation', array( $this, 'adf_tip_and_donation_shortcode' ));
		add_action( 'wp_head', array( $this, 'adf_tip_styling' ) );
		add_action('woocommerce_cart_updated', array( $this, 'af_tbw_session_unset_empty_cart' ) );
	}

	/**
	 * Af_tbw_add_settings_tab
	 *
	 * @param object $cart_object return cartobject .
	 */
	public function af_tbw_tip_donate_calculation( $cart_object ) {

		$af_tbw_tax_enable                         = false;
		$af_tbw_enable_tipping_or_donation_taxable = get_option( 'af_tbw_enable_tipping_or_donation_taxable' );

		if ( 'yes' == $af_tbw_enable_tipping_or_donation_taxable ) {

			$af_tbw_tax_enable = true;
		}

		$af_tbw_restriction_found = false;
		$af_tbw_restriction_found = $this->af_tbw_check_restrictions();

		if ( ( ( empty( (array) get_option( 'af_tbw_products_tipping_or_donation_restriction_product_ids' ) ) ) &&
			( empty( (array) get_option( 'af_tbw_categories_tipping_donation_restriction_category_ids' ) ) ) &&
			( empty( (array) get_option( 'af_tbw_shipping_tipping_or_donation_restriction_shipping_method_ids' ) ) ) ) ||
			( true == ( $af_tbw_restriction_found ) ) ) {

			$af_tbw_subtotal_excl_tax = 0;
		$af_tbw_subtotal_incl_tax     = 0;

			foreach ( $cart_object->get_cart() as $af_tbw_cart_item ) {
				if ( isset( $af_tbw_cart_item['line_subtotal'] ) ) {
					$af_tbw_subtotal_excl_tax += $af_tbw_cart_item['line_subtotal'];
					$af_tbw_subtotal_incl_tax += $af_tbw_cart_item['line_subtotal'] + $af_tbw_cart_item['line_subtotal_tax'];
				}
			}

			if ( 0 !== ( WC()->session->get( 'af_tbw_tipping_donation_fixed' ) ) ) {
				$af_tbw_woocommerce_session_fixed = WC()->session->get( 'af_tbw_tipping_donation_fixed' );
				wc()->cart->add_fee( get_option( 'af_tipping_or_donation_summary_title' ), $af_tbw_woocommerce_session_fixed, $af_tbw_tax_enable );

			}

			if ( 0 !== ( WC()->session->get( 'af_tbw_tipping_donation_percentage' ) ) ) {
				$af_tbw_woocommerce_session_percentage                  = WC()->session->get( 'af_tbw_tipping_donation_percentage' );
				$af_tbw_is_percent_calcultated                          = WC()->session->set( 'af_tbw_is_percent_calcultated', $af_tbw_woocommerce_session_percentage );
				$af_tbw_woocommerce_session_calculated_perceentage_data = $af_tbw_subtotal_excl_tax * ( $af_tbw_woocommerce_session_percentage / 100 );

				WC()->session->set( 'af_tbw_tipping_donation_percentage_calculated', $af_tbw_woocommerce_session_calculated_perceentage_data );
				wc()->cart->add_fee( get_option( 'af_tipping_or_donation_summary_title' ), (float) $af_tbw_woocommerce_session_calculated_perceentage_data, $af_tbw_tax_enable );

			}
		} else {
			$this->af_tbw_session_unset();
		}
	}
	
	public function af_modify_donation_fee_amount_display( $fee_html, $fee ) {
		if ( get_option( 'af_tipping_or_donation_summary_title') === $fee->name  ) {
			if ( 0 !== ( WC()->session->get( 'af_tbw_tipping_donation_fixed' ) ) || 0 !== WC()->session->get( 'af_tbw_tipping_donation_percentage' ) ) {
				$af_tbw_tipping_donation_percentage = $fee_html;
				$adf_donation_type                  = get_option('af_tbw_tipping_or_donation_precentage_options');
				if ( 'popup' == $adf_donation_type) {
					$fee_html = $fee_html . '<a href="javascript:void(0)" class="af_tbw_change_donation">Change</a>';
				} else {
					$fee_html = $fee_html . ' <a href="javascript:void(0)" class="af_tbw_removedata">Remove</a>';
				}
			}
		}

		return $fee_html;
	}
	/**
	 * Init().
	 */
	public function af_tbw_init() {

		$af_tbw_enable_tipping_or_donation = get_option( 'af_tbw_enable_tipping_or_donation' );
		$af_tbw_tipping_or_donation_type   = get_option( 'af_tbw_tipping_or_donation_type', 'fixed' );

		if ( 'yes' == $af_tbw_enable_tipping_or_donation ) {

			if ( WC()->cart && ! WC()->cart->is_empty() ) {

				if ( 'fixed' === $af_tbw_tipping_or_donation_type ) {

					WC()->session->set( 'af_tbw_tipping_donation_percentage', 0 );

				} elseif ( 'percentage' === $af_tbw_tipping_or_donation_type ) {

					WC()->session->set( 'af_tbw_tipping_donation_fixed', 0 );
				}

				$af_tbw_tipping_or_donation_feilds                          = get_option( 'af_tbw_tipping_or_donation_feilds' );
				$af_tbw_tipping_or_donation_on_cart_page_display_option     = get_option( 'af_tbw_tipping_or_donation_on_cart_page_display_option' );
				$af_tbw_tipping_or_donation_on_checkout_page_display_option = get_option( 'af_tbw_tipping_or_donation_on_checkout_page_display_option' );

				switch ( $af_tbw_tipping_or_donation_feilds ) {
					case 'cart_only':
					add_action( $af_tbw_tipping_or_donation_on_cart_page_display_option, array( $this, 'af_tbw_tipping_or_donation_display' ) );
						break;

					case 'checkout_only':
					add_action( $af_tbw_tipping_or_donation_on_checkout_page_display_option, array( $this, 'af_tbw_tipping_or_donation_display' ) );
						break;

					default:
					add_action( $af_tbw_tipping_or_donation_on_cart_page_display_option, array( $this, 'af_tbw_tipping_or_donation_display' ) );
					add_action( $af_tbw_tipping_or_donation_on_checkout_page_display_option, array( $this, 'af_tbw_tipping_or_donation_display' ) );
						break;
				}
			}
		} elseif ( ( WC()->cart && WC()->cart->is_empty() ) ) {

			$this->af_tbw_session_unset();
		}
	}

	public function adf_tip_styling() {
		$button_text_color                             = get_option('af_tbw_button_text_color');
		$button_bg_color                               = get_option('af_tbw_button_background_color');
		$border_color                                  = get_option('af_tbw_border_color');
		$af_options_color                              = get_option('af_tbw_element_color');
		$af_tbw_options_background_color               = get_option('af_tbw_element_background_color');
		$af_tbw_options_border                         = get_option('af_tbw_element_border');
		$af_tbw_options_border_radius                  = get_option('af_tbw_element_border_radius');
		$af_tbw_button_hover_bg_color                  = get_option('af_tbw_button_hover_bg_color');
		$af_tbw_background_width                       = get_option('af_tbw_background_width');
		$af_tbw_element_hover_color                    = get_option('af_tbw_element_hover_color');
		$af_tbw_element_bg_hover_color                 = get_option('af_tbw_element_bg_hover_color');
		$af_tbw_button_hover_color                     = get_option('af_tbw_button_hover_color');
		$af_tbw_box_background_color                   = get_option('af_tbw_box_background_color');
		$af_tbw_box_text_color                         = get_option('af_tbw_box_text_color');
		$af_tbw_button_border                          = get_option('af_tbw_button_border');
		$af_tbw_box_border_color                       = get_option('af_tbw_box_border_color');
		$af_tbw_button_border_color                    = get_option('af_tbw_button_border_color');
		$af_tbw_button_border_radius                   = get_option('af_tbw_button_border_radius');
		$af_tbw_element_radio_btn_color                = get_option('af_tbw_element_radio_btn_color');
		$af_tbw_tipping_or_donation_precentage_options = get_option('af_tbw_tipping_or_donation_precentage_options');
		$af_tbw_custom_css                             = get_option('af_tbw_custom_css');
		?>
		<style>
	
			.af_tbw_tipping_donation_div_get.select_box, .af_tbw_tipping_donation_div_get.Buttons, .af_tbw_tipping_donation_div_get.radio_btn, .af_tbw_tipping_donation_div_get.popup .adf-main-popup, .adf-tad-shortcode-main .adf-main-popup{
				background-color: <?php echo $af_tbw_box_background_color ? esc_attr($af_tbw_box_background_color):'#fff'; ?>;
				color: <?php echo $af_tbw_box_text_color ? esc_attr($af_tbw_box_text_color):'#000'; ?>;
				border-color: <?php echo $af_tbw_box_border_color ? esc_attr($af_tbw_box_border_color):'#000'; ?>;
			}
			.popup-heading h3{
				color: <?php echo $af_tbw_box_text_color ? esc_attr($af_tbw_box_text_color):'#000'; ?>;
			}
			.af_tbw_tipping_donation_div_get.Buttons{
				width: <?php echo $af_tbw_background_width ? esc_attr($af_tbw_background_width) . '%': 'fit-content' ; ?>!important;
			}
			.af_tbw_other_options_fixed_wrap .af_tbw_select_fixed_btn, .adf-tip-others-btn .af_tbw_donate_button,
			.af_tbw_other_options_fixed_wrap .af_tbw_select_percentage, .adf-tip-others-btn .af_tbw_other_percent,
			.af_tbw_other_options .af_tbw_other_percent, .af_tbw_other_options_fixed .af_tbw_donate_button,
			.af_tbw_other_options_percentage_popup .af_tbw_popup_percent, .af_tbw_other_options_percentage_popup .af_tbw_removedata,
			.af_tbw_other_options_percentage_popup .af_tbw_popup_fixed, .adf-shortcode-popup-btn .adf-popup-btn{
				background-color: <?php echo esc_attr($button_bg_color); ?>;
				color: <?php echo esc_attr($button_text_color); ?>;
				<?php if (!empty($af_tbw_button_border)) { ?>
				border:<?php echo esc_attr($af_tbw_button_border); ?>px solid;
				<?php } ?>
				border-color: <?php echo esc_attr($af_tbw_button_border_color); ?>;
				<?php if (!empty($af_tbw_button_border)) { ?>
				border-radius: <?php echo esc_attr($af_tbw_button_border_radius); ?>px;
				<?php } ?>
				padding: 10px 15px;
				font-size: 15px;
				line-height: 23px;
				margin-left: 10px;
			}
			.af_tbw_other_options_fixed input, .af_tbw_other_options input,
			.adf_popup-other-field-percentage .af_tbw_fixed_amount, .adf_popup-other-field-percentage .af_tbw_other_percentage{
				<?php if (!empty($af_tbw_button_border)) { ?>
				border-radius: <?php echo esc_attr($af_tbw_button_border_radius); ?>px;
				<?php } ?>
			}
			.af_tbw_other_options_percentage_popup .af_tbw_popup_percent,
			.af_tbw_other_options_percentage_popup .af_tbw_popup_fixed{
				margin-left: 0!important;
			}
			.af_tbw_other_options_fixed_wrap .af_tbw_select_fixed_btn:hover, .adf-tip-others-btn .af_tbw_donate_button:hover,
			.af_tbw_other_options_fixed_wrap .af_tbw_select_percentage:hover, .adf-tip-others-btn .af_tbw_other_percent:hover,
			.af_tbw_other_options .af_tbw_other_percent:hover, .af_tbw_other_options_fixed .af_tbw_donate_button:hover,
			.af_tbw_other_options_percentage_popup .af_tbw_popup_percent:hover, .af_tbw_other_options_percentage_popup .af_tbw_removedata:hover,
			.af_tbw_other_options_percentage_popup .af_tbw_popup_fixed:hover, .adf-shortcode-popup-btn .adf-popup-btn:hover{
				background-color: <?php echo $af_tbw_button_hover_bg_color ? esc_attr($af_tbw_button_hover_bg_color): '#5f5959'; ?>;
				color: <?php echo $af_tbw_button_hover_color ? esc_attr($af_tbw_button_hover_color): '#fff'; ?>;
			}
			.adf-button-tempalte-wrap .af_tbw_btn_donate_button, .adf-button-tempalte-wrap .other,
			.adf-button-tempalte-wrap .af_tbw_btn_donate_fixed_button,
			.adf-button-tempalte-wrap  .fixed-other, .adf-popup-options,
			.adf-popup-pre-defined-value .adf-popup-options{
				background-color: <?php echo esc_attr($af_tbw_options_background_color); ?>;
				color: <?php echo esc_attr($af_options_color); ?>;
				border-radius: <?php echo esc_attr($af_tbw_options_border_radius); ?>px;
				<?php if (!empty($af_tbw_options_border)) { ?>
				border: <?php echo esc_attr($af_tbw_options_border); ?>px solid;
				border-color: <?php echo esc_attr($border_color); ?>;
				<?php } ?>
			}
			.af_tbw_tipping_donation_div_get.Buttons .adf-button-tempalte-wrap button:hover,
			.af_tbw_tipping_donation_div_get.Buttons .adf-button-tempalte-wrap button:active,
			.af_tbw_tipping_donation_div_get.Buttons .adf-button-tempalte-wrap button:focus,
			.adf-popup-pre-defined-value .adf-popup-options:hover,
			.adf-popup-pre-defined-value .adf-popup-options:focus,
			.adf-popup-pre-defined-value .adf-popup-options:active, .adf-popup-options.active{
				background-color: <?php echo esc_attr($af_tbw_element_bg_hover_color); ?>;
				color: <?php echo esc_attr($af_tbw_element_hover_color); ?>;
			}
				.adf-radio-btn-tempalte-wrap .adf-radio-btn .af_tbw_label_css_setting:hover,
			.adf-radio-btn-tempalte-wrap .adf-radio-btn .af_tbw_label_css_setting:active,
			.adf-radio-btn-tempalte-wrap .adf-radio-btn .af_tbw_label_css_setting:focus,
			.adf-radio-btn-tempalte-wrap .adf-radio-btn .af_tbw_label_css_setting input:hover,
			.adf-radio-btn-tempalte-wrap .adf-radio-btn .af_tbw_label_css_setting input:active,
			.adf-radio-btn-tempalte-wrap .adf-radio-btn .af_tbw_label_css_setting input:focus{
				color: <?php echo esc_attr($af_tbw_element_hover_color); ?>;
				accent-color:  <?php echo esc_attr($af_tbw_element_hover_color); ?>;
			}
			.adf-radio-btn-tempalte-wrap .adf-radio-btn .af_tbw_label_css_setting{
				<?php if ('radio_btn' == $af_tbw_tipping_or_donation_precentage_options) { ?>
					color: <?php echo esc_attr($af_tbw_element_radio_btn_color); ?>;
					accent-color:  <?php echo esc_attr($af_tbw_element_radio_btn_color); ?>;
				<?php } else { ?>
					color: <?php echo esc_attr($af_options_color); ?>;
					accent-color:  <?php echo esc_attr($af_options_color); ?>;
				<?php } ?>
			}
			.adf-shortcode-popup-btn .adf-popup-btn{
				margin-left: 0;
			}

			@media screen and ( max-width:800px){
				.af_tbw_tipping_donation_div_get.Buttons{
					width: 100%!important;
						box-sizing: border-box;
				}
				.af_tbw_tipping_donation_div_get.Buttons .adf-button-tempalte-wrap button,
				.adf-radio-btn-tempalte-wrap .adf-radio-btn, .adf-popup-pre-defined-value .adf-popup-options{
					min-width: 93px;
						box-sizing: border-box;
				}
				.af_tbw_tipping_donation_div_get.Buttons .af_tbw_other_options_fixed, .af_tbw_tipping_donation_div_get.Buttons .af_tbw_other_options, .af_tbw_tipping_donation_div_get.radio_btn .af_tbw_other_options, .af_tbw_tipping_donation_div_get.radio_btn .af_tbw_other_options_fixed{
					width: 100%!important;
						box-sizing: border-box;
				}
				.adf-main-popup{
					width: 92%;
					box-sizing: border-box;
				}
			}
			<?php
			echo esc_attr($af_tbw_custom_css);
			?>
		</style>
		<?php
	}
	/**
	 * Af_tbw_check_restrictions.
	 */
	public function af_tbw_check_restrictions() {

		$af_tbw_products_tipping_or_donation_restriction_product_ids         = (array) get_option( 'af_tbw_products_tipping_or_donation_restriction_product_ids' );
		$af_tbw_categories_tipping_donation_restriction_category_ids         = (array) get_option( 'af_tbw_categories_tipping_donation_restriction_category_ids' );
		$af_tbw_shipping_tipping_or_donation_restriction_shipping_method_ids = (array) get_option( 'af_tbw_shipping_tipping_or_donation_restriction_shipping_method_ids' );

		$af_tbw_user_selected_shipping_method_id = '';
		if ( ! empty( WC()->session->get( 'chosen_shipping_methods' ) ) ) {
			$adf_shipping_method = WC()->session->get( 'chosen_shipping_methods' );
			if ( isset( explode( ':', reset($adf_shipping_method ) )[0] ) ) {
				$af_tbw_user_selected_shipping_method_id = explode( ':', reset( $adf_shipping_method ) )[0];
			}
		}

		if ( ( in_array( $af_tbw_user_selected_shipping_method_id, $af_tbw_shipping_tipping_or_donation_restriction_shipping_method_ids ) ) ) {

			return true;
		}
		// outer foreach that iterates for cart produt ids.
		foreach ( WC()->cart->get_cart() as $af_tbw_item_key => $af_tbw_cart_item ) {

			if ( in_array( $af_tbw_cart_item['product_id'], $af_tbw_products_tipping_or_donation_restriction_product_ids ) ) {

				return true;
			}
			// inner foreach that iterates for cart categories ids using single prduct id.
			foreach ( $af_tbw_categories_tipping_donation_restriction_category_ids as $af_tbw_catid ) {

				if ( has_term( $af_tbw_catid, 'product_cat', $af_tbw_cart_item['product_id'] ) ) {

					return true;
				}
			}
		}
	}
	/**
	 * Af_tbw_tipping_or_donation_display.
	 */
	public function af_tbw_tipping_or_donation_display() {

		if ( WC()->cart && WC()->cart->is_empty() ) {

			return;
		}
		$current_user_role   = is_user_logged_in() ? wp_get_current_user()->roles : array( 'guest' );
		$af_tipping_userrole = get_option('af_tipping_or_donation_userrole');
		if ( ! empty( $af_tipping_userrole ) && !empty($current_user_role) ) {
			$count_match_roles = array_intersect( (array) $af_tipping_userrole, $current_user_role );
			if (empty($count_match_roles)) {
				return;
			}
		}
		$af_tbw_tipping_or_donation_precentage_options = get_option( 'af_tbw_tipping_or_donation_precentage_options' );

			$af_tbw_tipping_detail = (array) WC()->session->get( 'af_tbw_tipping_detail' );

			$type         = isset( $af_tbw_tipping_detail['type'] ) ? $af_tbw_tipping_detail['type'] : '';
			$custom_value = isset( $af_tbw_tipping_detail['custom_value'] ) ? $af_tbw_tipping_detail['custom_value'] : '';

			$af_tbw_restriction_found = false;
			$af_tbw_restriction_found = $this->af_tbw_check_restrictions();

		if ( ( ( empty( (array) get_option( 'af_tbw_products_tipping_or_donation_restriction_product_ids' ) ) ) &&
				( empty( (array) get_option( 'af_tbw_categories_tipping_donation_restriction_category_ids' ) ) ) &&
				( empty( (array) get_option( 'af_tbw_shipping_tipping_or_donation_restriction_shipping_method_ids' ) ) ) ) ||
				( true == ( $af_tbw_restriction_found ) ) ) {
			?>
				<div  class="af_tbw_tipping_donation_div_get <?php echo esc_attr($af_tbw_tipping_or_donation_precentage_options); ?>"  id="af_tbw_tipping_donation_div" >
				<?php

				$af_tbw_tipping_or_donation_type = get_option( 'af_tbw_tipping_or_donation_type', 'fixed' );
				
				$af_tbw_tipping_or_donation_button_text  = get_option( 'af_tbw_tipping_or_donation_button_text', 'Tip/donate' );
				$af_tbw_percentage_predefiend_values     = get_option( 'af_tbw_percentage_predefiend_values', '5,10,15' );
				$af_tbw_tipping_or_donation_message_text = get_option( 'af_tbw_tipping_or_donation_message_text', 'tip/donate ?' );
				$af_tbw_tipping_or_donation_heading_text = get_option( 'af_tbw_tipping_or_donation_heading_text', 'tip/donate' );
				
				$af_tbw_fixed_placeholder       = get_option( 'af_tbw_fixed_placeholder' );
				$af_td_other_btn_text           = get_option( 'af_td_other_btn_text' );
				$af_td_other_field_place_holder = get_option('af_td_other_field_place_holder'); 
				$af_tbw_fixed_predefiend_values = get_option( 'af_tbw_fixed_placeholder', '5,10,15' );
				?>
				
				<?php

				if ( 'fixed' === $af_tbw_tipping_or_donation_type ) {

					switch ( $af_tbw_tipping_or_donation_precentage_options ) {

						case 'radio_btn':
							?>
							<div class="popup-heading">
								<h3><?php echo esc_html( $af_tbw_tipping_or_donation_heading_text ); ?></h3>
								<p><?php echo esc_attr( $af_tbw_tipping_or_donation_message_text ); ?></p>
							</div>
							<?php
							if ( $af_tbw_fixed_predefiend_values ) {
								$af_radiobutton_fixed_values = explode( ',', $af_tbw_fixed_predefiend_values );
								$af_radiobutton_fixed_values = array_unique( $af_radiobutton_fixed_values );
								?>
								<div class="adf-radio-btn-tempalte-wrap">
									<?php
									foreach ( $af_radiobutton_fixed_values as $af_radiobutton_fixed_value ) {
										?>
										<div class="adf-radio-btn">
										<label class="af_tbw_label_css_setting">
											<input type="radio" class="af_tbw_radio_button_fixed"  <?php echo esc_attr( $af_radiobutton_fixed_value == $type ? 'checked' : '' ); ?> name="af_tbw_radio_button_fixed_option" value="<?php echo esc_attr( $af_radiobutton_fixed_value ); ?>" data-af_tbw_radio_btn_fixed="<?php echo esc_attr( $af_radiobutton_fixed_value ); ?> " >
											<span style="margin-left:5px;"class="af_tbw_radio_button_text"  >
												<?php echo esc_attr( get_woocommerce_currency_symbol() ) . ' ' . esc_attr( $af_radiobutton_fixed_value ); ?></span>
											</label>
										</div>
										<?php
									}
									?>
									<div class="adf-radio-btn">
										<label class="af_tbw_label_css_setting" >
											<input type="radio" class="fixed-other"   name="af_tbw_radio_button_fixed_option" <?php echo esc_attr( 'others' == $type ? 'checked' : '' ); ?>>
											<span class="af_radio_button_text" ><?php echo $af_td_other_btn_text ? esc_html($af_td_other_btn_text) : 'other'; ?></span>
										</label>
									</div>
								</div>
								<div class="af_tbw_other_options_fixed" style="display:none; margin-top:8px">
									<input type="number" class="af_tbw_fixed_amount_donate"  name="af_tbw_fixed_amount" min="0" placeholder="<?php echo $af_td_other_field_place_holder ? esc_attr($af_td_other_field_place_holder):'Add amount'; ?>" >
									<button type="button" class="button alt af_tbw_donate_button" name="tipping_donation"><?php echo esc_html( $af_tbw_tipping_or_donation_button_text ); ?></button>
								</div>
								<?php
							}
							break;
						case 'Buttons':
							?>
							<div class="popup-heading">
								<h3><?php echo esc_html( $af_tbw_tipping_or_donation_heading_text ); ?></h3>
								<p><?php echo esc_attr( $af_tbw_tipping_or_donation_message_text ); ?></p>
							</div>
							<div class="adf-button-tempalte-wrap">
								<?php
								if ( $af_tbw_fixed_predefiend_values ) {
									$af_button_fixed_values = explode( ',', $af_tbw_fixed_predefiend_values );
									$af_button_fixed_values = array_unique( $af_button_fixed_values );
									foreach ( $af_button_fixed_values as $af_button_fixed_value ) {
										?>
										<button  type="button" class="button alt af_tbw_btn_donate_fixed_button" data-af_tbw_fixed_btn="<?php echo esc_attr( $af_button_fixed_value ); ?>" name="button_percentage"><?php echo esc_attr( get_woocommerce_currency_symbol() ) . ' ' . esc_attr( $af_button_fixed_value ); ?></button>
										<?php
									}
								}
								?>
								<button type="button" class="button alt fixed-other"  ><?php echo $af_td_other_btn_text ? esc_html($af_td_other_btn_text) : 'other'; ?></button>
							</div>
							<div class="af_tbw_other_options_fixed" style="display:none; margin-top:8px">
								<input type="number" class="af_tbw_fixed_amount_donate"  name="af_tbw_fixed_amount" min="0" placeholder="<?php echo $af_td_other_field_place_holder ? esc_attr($af_td_other_field_place_holder):'Add amount'; ?>">
								<button type="button" class="button alt af_tbw_donate_button" name="tipping_donation"><?php echo esc_html( $af_tbw_tipping_or_donation_button_text ); ?></button>
							</div>
							<?php
							break;
						case 'popup':
							?>
							<div class="adf-main-popup" style="display: none;">
								<i class="af-close-popup ">×</i>
								<div class="adf-popup-wrap">
									<div class="popup-heading">
										<h3><?php echo esc_html( $af_tbw_tipping_or_donation_heading_text ); ?></h3>
										<p><?php echo esc_attr( $af_tbw_tipping_or_donation_message_text ); ?></p>
									</div>
									<div class="adf-popup-pre-defined-value">
										<?php
										if ( $af_tbw_fixed_predefiend_values ) {
											$af_button_fixed_values = explode( ',', $af_tbw_fixed_predefiend_values );
											$af_button_fixed_values = array_unique( $af_button_fixed_values );
											foreach ( $af_button_fixed_values as $af_button_fixed_value ) {
												?>
												<label class="adf-popup-options">
													<input type="radio" class="af_tbw_popup_button"  <?php echo esc_attr( $af_button_fixed_value == $type ? 'checked' : '' ); ?> name="af_tbw_button_fixed_popup" value="<?php echo esc_attr( $af_button_fixed_value ); ?>" data-af_tbw_popup="<?php echo esc_attr( $af_button_fixed_value ); ?> " >
													<span class="af_tbw_popup_button_text"  ><?php echo esc_attr( get_woocommerce_currency_symbol() ) . ' ' . esc_attr( $af_button_fixed_value ); ?></span>
												</label>
												<?php
											}
										}
										?>
									</div>
									<div class="adf_popup-other-field-percentage">
										<?php $af_td_other_field_place_holder = get_option('af_td_other_field_place_holder'); ?>
										<input type="number" value="<?php echo esc_attr( $custom_value ); ?>" class="af_tbw_fixed_amount" name="af_tbw_fixed_amount"  min="0" placeholder="<?php echo $af_td_other_field_place_holder ? esc_attr($af_td_other_field_place_holder):'Add amount'; ?>" >
									</div>
									<div class="af_tbw_other_options_percentage_popup" style="margin-top:15px">
										<button type="button" class="button alt af_tbw_popup_fixed" ><?php echo esc_html( $af_tbw_tipping_or_donation_button_text ); ?></button>
										<button type="button" class="button alt af_tbw_removedata" style="display: none;"><?php echo esc_html__('Remove', 'addify-tipping-at-cart-checkout'); ?></button>
									</div>
								</div>
							</div>
							<?php
							break;
						default:
							?>
							<div class="popup-heading">
								<h3><?php echo esc_html( $af_tbw_tipping_or_donation_heading_text ); ?></h3>
								<p><?php echo esc_attr( $af_tbw_tipping_or_donation_message_text ); ?></p>
							</div>
							<?php
							if ( $af_tbw_fixed_predefiend_values ) {
								?>
								<div class="af_tbw_other_options_fixed_wrap">
									<select class="af_tbw_select_fixed" name="af_tbw_fixed_select">
										<?php
										$af_tbw_selectbox_fixed_values = explode( ',', $af_tbw_fixed_predefiend_values );
										$af_tbw_selectbox_fixed_values = array_unique( $af_tbw_selectbox_fixed_values );

										foreach ( $af_tbw_selectbox_fixed_values as $af_selectbox_fixed_value ) {
											?>
											<option <?php echo esc_attr( $af_selectbox_fixed_value == $type ? 'selected' : '' ); ?> class="af_tbw_select_option_percentage" value="<?php echo esc_attr( $af_selectbox_fixed_value ); ?>" data-id="<?php echo esc_attr( $af_selectbox_fixed_value ); ?>"><?php echo esc_attr( get_woocommerce_currency_symbol() ) . ' ' . esc_attr( $af_selectbox_fixed_value ); ?> </option>
											<?php
										}
										?>
										<option <?php echo esc_attr( 'others' == $type ? 'selected' : '' ); ?> class="af_tbw_select_option_percentage" value="others"><?php echo $af_td_other_btn_text ? esc_html($af_td_other_btn_text) : 'other'; ?></option>
									</select>
									<button type="button" class="button alt af_tbw_select_fixed_btn" ><?php echo esc_html( $af_tbw_tipping_or_donation_button_text ); ?></button>
								</div>
								<div class="adf-tip-others-btn">
									<input type="number" class="af_tbw_fixed_amount_donate af_tbw_other_options_fixed"  name="af_tbw_fixed_amount" min="0" placeholder="<?php echo $af_td_other_field_place_holder ? esc_attr($af_td_other_field_place_holder):'Add amount'; ?>" style="display:none;">
									<button type="button" class="button alt af_tbw_donate_button af_tbw_other_options_fixed" name="tipping_donation" style="display:none;"><?php echo esc_html( $af_tbw_tipping_or_donation_button_text ); ?></button>
								</div>
									
									<?php
							}
							break;
					}
				
				} elseif ( 'percentage' === $af_tbw_tipping_or_donation_type ) {

					switch ( $af_tbw_tipping_or_donation_precentage_options ) {

						case 'radio_btn':
							?>
							<div class="popup-heading">
								<h3><?php echo esc_html( $af_tbw_tipping_or_donation_heading_text ); ?></h3>
								<p><?php echo esc_attr( $af_tbw_tipping_or_donation_message_text ); ?></p>
							</div>
							<?php
							if ( $af_tbw_percentage_predefiend_values ) {
								$af_radiobutton_percentage_values = explode( ',', $af_tbw_percentage_predefiend_values );
								$af_radiobutton_percentage_values = array_unique( $af_radiobutton_percentage_values );
								?>
									<div class="adf-radio-btn-tempalte-wrap">
									<?php
									foreach ( $af_radiobutton_percentage_values as $af_radiobutton_percentage_value ) {
										?>
											<div class="adf-radio-btn">
											<label class="af_tbw_label_css_setting">
												<input type="radio" class="af_tbw_radio_button"  <?php echo esc_attr( $af_radiobutton_percentage_value == $type ? 'checked' : '' ); ?> name="af_tbw_radio_button_percentage_option" value="<?php echo esc_attr( $af_radiobutton_percentage_value ); ?>" data-af_tbw_radio_btn="<?php echo esc_attr( $af_radiobutton_percentage_value ); ?> " >
												<span style="margin-left:5px;"class="af_tbw_radio_button_text"  >
												<?php echo esc_attr( $af_radiobutton_percentage_value ); ?> %</span>
												</label>
											</div>
										<?php
									}
									?>
										<div class="adf-radio-btn">
											<label class="af_tbw_label_css_setting" >
												<input type="radio" class="other" name="af_tbw_radio_button_percentage_option" <?php echo esc_attr( 'others' == $type ? 'checked' : '' ); ?>>
												<span class="af_radio_button_text" ><?php echo $af_td_other_btn_text ? esc_html($af_td_other_btn_text) : 'other'; ?></span>
											</label>
										</div>
									</div>
									<div class="af_tbw_other_options" style="display:none; margin-top:8px">
										<input type="number" value="<?php echo esc_attr( $custom_value ); ?>"  class="af_tbw_other_percentage" name="af_tbw_other_percentage"  min="0" placeholder="<?php echo $af_td_other_field_place_holder ? esc_attr($af_td_other_field_place_holder):'Add amount'; ?>" >
										<button type="button" class="button alt af_tbw_other_percent"><?php echo esc_html( $af_tbw_tipping_or_donation_button_text ); ?></button>
									</div>
								<?php
							}
							break;
						case 'Buttons':
							?>
							<div class="popup-heading">
								<h3><?php echo esc_html( $af_tbw_tipping_or_donation_heading_text ); ?></h3>
								<p><?php echo esc_attr( $af_tbw_tipping_or_donation_message_text ); ?></p>
							</div>
							<div class="adf-button-tempalte-wrap">
								<?php
								if ( $af_tbw_percentage_predefiend_values ) {
									$af_button_percentage_values = explode( ',', $af_tbw_percentage_predefiend_values );
									$af_button_percentage_values = array_unique( $af_button_percentage_values );
									foreach ( $af_button_percentage_values as $af_button_percentage_value ) {
										?>
										<button  type="button" class="button alt af_tbw_btn_donate_button" data-af_tbw_percentage_btn="<?php echo esc_attr( $af_button_percentage_value ); ?>" name="button_percentage"><?php echo esc_attr( $af_button_percentage_value ); ?> %</button>
										<?php
									}
								}
								?>
								<button type="button" class="button alt other"  ><?php echo $af_td_other_btn_text ? esc_html($af_td_other_btn_text) : 'other'; ?></button>
							</div>
							<div class="af_tbw_other_options" style="display:none; margin-top:8px">
								<input type="number" value="<?php echo esc_attr( $custom_value ); ?>"  class="af_tbw_other_percentage" name="af_tbw_other_percentage"  min="0" placeholder="<?php echo $af_td_other_field_place_holder ? esc_attr($af_td_other_field_place_holder):'Add amount'; ?>" >
								<button type="button" class="button alt af_tbw_other_percent"><?php echo esc_html( $af_tbw_tipping_or_donation_button_text ); ?></button>
							</div>
							<?php
							break;
						case 'popup':
							?>
							<div class="adf-main-popup" style="display: none;">
								<i class="af-close-popup ">×</i>
								<div class="adf-popup-wrap">
									<div class="popup-heading">
										<h3><?php echo esc_html( $af_tbw_tipping_or_donation_heading_text ); ?></h3>
										<p><?php echo esc_attr( $af_tbw_tipping_or_donation_message_text ); ?></p>
									</div>
									<div class="adf-popup-pre-defined-value">
									<?php
									if ( $af_tbw_percentage_predefiend_values ) {
										$af_button_percentage_values = explode( ',', $af_tbw_percentage_predefiend_values );
										$af_button_percentage_values = array_unique( $af_button_percentage_values );
										foreach ( $af_button_percentage_values as $af_button_percentage_value ) {
											?>
											<label class="adf-popup-options">
												<input type="radio" class="af_tbw_popup_button"  <?php echo esc_attr( $af_button_percentage_value == $type ? 'checked' : '' ); ?> name="af_tbw_button_percentage_popup" value="<?php echo esc_attr( $af_button_percentage_value ); ?>" data-af_tbw_popup="<?php echo esc_attr( $af_button_percentage_value ); ?> " >
												<span class="af_tbw_popup_button_text"  >
													<?php echo esc_attr( $af_button_percentage_value ); ?> %</span>
											</label>
											<?php
										}
									}
									?>
									</div>
									<div class="adf_popup-other-field-percentage">
										<?php $af_td_other_field_place_holder = get_option('af_td_other_field_place_holder'); ?>
										<input type="number" value="<?php echo esc_attr( $custom_value ); ?>" class="af_tbw_other_percentage" name="af_tbw_other_percentage"  min="0" placeholder="<?php echo $af_td_other_field_place_holder ? esc_attr($af_td_other_field_place_holder):'Add amount'; ?>" >
									</div>
									<div class="af_tbw_other_options_percentage_popup" style="margin-top:15px">
										<button type="button" class="button alt af_tbw_popup_percent" ><?php echo esc_html( $af_tbw_tipping_or_donation_button_text ); ?></button>
										<button type="button" class="button alt af_tbw_removedata" style="display: none;"><?php echo esc_html__('Remove', 'addify-tipping-at-cart-checkout'); ?></button>
									</div>
								</div>
							</div>
							<?php


							break;
						default:
							if ( $af_tbw_percentage_predefiend_values ) {
								?>
							<div class="popup-heading">
								<h3><?php echo esc_html( $af_tbw_tipping_or_donation_heading_text ); ?></h3>
								<p><?php echo esc_attr( $af_tbw_tipping_or_donation_message_text ); ?></p>
							</div>
							<div class="af_tbw_other_options_fixed_wrap">
								<select   class="af_tbw_Select_percentage" name="af_tbw_fixed_select">
									<?php
									$af_tbw_selectbox_percentage_values = explode( ',', $af_tbw_percentage_predefiend_values );
									$af_tbw_selectbox_percentage_values = array_unique( $af_tbw_selectbox_percentage_values );

									foreach ( $af_tbw_selectbox_percentage_values as $af_selectbox_percentage_value ) {
										?>
										<option <?php echo esc_attr( $af_selectbox_percentage_value == $type ? 'selected' : '' ); ?> class="af_tbw_select_option_percentage" value="<?php echo esc_attr( $af_selectbox_percentage_value ); ?>" data-id="<?php echo esc_attr( $af_selectbox_percentage_value ); ?>"><?php echo esc_attr( $af_selectbox_percentage_value ); ?> % </option>
										<?php
									}
									?>
									<option <?php echo esc_attr( 'others' == $type ? 'selected' : '' ); ?> class="af_tbw_select_option_percentage" value="others"><?php echo $af_td_other_btn_text ? esc_html($af_td_other_btn_text) : 'other'; ?></option>
								</select>
								<button type="button" class="button alt af_tbw_select_percentage"><?php echo esc_html( $af_tbw_tipping_or_donation_button_text ); ?></button>
							</div>
							<div class="adf-tip-others-btn">
								<input type="number" value="<?php echo esc_attr( $custom_value ); ?>"  class="af_tbw_other_options af_tbw_other_percentage" name="af_tbw_other_percentage"  min="0" placeholder="<?php echo $af_td_other_field_place_holder ? esc_attr($af_td_other_field_place_holder):'Add amount'; ?>" style="display:none;">
								<button type="button" class="button alt af_tbw_other_percent af_tbw_other_options" style="display:none;"><?php echo esc_html( $af_tbw_tipping_or_donation_button_text ); ?></button>
								
							</div>
								<?php
							}
							break;
					}
				}

				?>
			</div>
			<?php
				
		} else {
			$this->af_tbw_session_unset();
		}
	}

		/**
	 * Adf_tip_and_donation_shortcode.
	 */
	public function adf_tip_and_donation_shortcode() {
		ob_start();

		$adf_tad_shortcode_enable = get_option('af_tbw_enable_tipping_or_donation_shortcode');
		if ( 'yes' !== $adf_tad_shortcode_enable) {
			return;
		}
		$current_user_role   = is_user_logged_in() ? wp_get_current_user()->roles : array( 'guest' );
		$af_tipping_userrole = get_option('af_tipping_or_donation_userrole');
		$custom_value        = isset( $af_tbw_tipping_detail['custom_value'] ) ? $af_tbw_tipping_detail['custom_value'] : '';
		if ( ! empty( $af_tipping_userrole ) && !empty($current_user_role) ) {
			$count_match_roles = array_intersect( (array) $af_tipping_userrole, $current_user_role );
			if (empty($count_match_roles)) {
				return;
			}
		
		}
		$af_tbw_tipping_detail                   = (array) WC()->session->get( 'af_tbw_tipping_detail' );
		$type                                    = isset( $af_tbw_tipping_detail['type'] ) ? $af_tbw_tipping_detail['type'] : '';
		$af_tbw_tipping_or_donation_message_text = get_option( 'af_tbw_tipping_or_donation_message_text', 'tip/donate ?' );
		$af_tbw_tipping_or_donation_heading_text = get_option( 'af_tbw_tipping_or_donation_heading_text', 'tip/donate' );
		$af_tbw_tipping_or_donation_type         = get_option( 'af_tbw_tipping_or_donation_type');
		$af_tbw_fixed_predefiend_values          = get_option( 'af_tbw_fixed_placeholder', '5,10,15' );
		$af_tbw_percentage_predefiend_values     = get_option( 'af_tbw_percentage_predefiend_values', '5,10,15' );
		$af_td_other_btn_text                    = get_option( 'af_td_other_btn_text' );
		$af_tbw_tipping_or_donation_button_text  = get_option( 'af_tbw_tipping_or_donation_button_text', 'Tip/donate' );
		$af_tbw_enable_tipping_or_donation_shortcode_text    = get_option('af_tbw_enable_tipping_or_donation_text');
		$af_tbw_enable_tipping_or_donation_shortcode_content = get_option('af_tbw_enable_tipping_or_donation_content');
		?>
		<div class="adf-tad-shortcode-main">
			<div class="adf-shortcode-content">
				<div>
					<div class="sucess-message"></div>
					<h3><?php echo esc_html($af_tbw_enable_tipping_or_donation_shortcode_text); ?></h3>
					<p><?php echo esc_html($af_tbw_enable_tipping_or_donation_shortcode_content); ?></p>
				</div>
				<div class="adf-shortcode-popup-btn">
					<button type="button" class="adf-popup-btn"><?php echo esc_html( $af_tbw_tipping_or_donation_button_text ); ?></button>
				</div>
			</div>
			<div class="adf-main-popup" style="display: none;">
				<i class="af-close-popup ">×</i>
				<div class="adf-popup-wrap">
					<div class="popup-heading">
						<h3><?php echo esc_html( $af_tbw_tipping_or_donation_heading_text ); ?></h3>
						<p><?php echo esc_attr( $af_tbw_tipping_or_donation_message_text ); ?></p>
					</div>
					<?php
					if ( 'fixed' === $af_tbw_tipping_or_donation_type) {
						?>
						<div class="adf-popup-pre-defined-value">
							<?php
							if ( $af_tbw_fixed_predefiend_values ) {
								$af_button_fixed_values = explode( ',', $af_tbw_fixed_predefiend_values );
								$af_button_fixed_values = array_unique( $af_button_fixed_values );
								foreach ( $af_button_fixed_values as $af_button_fixed_value ) {
									?>
									<label class="adf-popup-options">
										<input type="radio" class="af_tbw_popup_button"  <?php echo esc_attr( $af_button_fixed_value == $type ? 'checked' : '' ); ?> name="af_tbw_button_fixed_popup" value="<?php echo esc_attr( $af_button_fixed_value ); ?>" data-af_tbw_popup="<?php echo esc_attr( $af_button_fixed_value ); ?> " ata-af-shortcode="yes">
										<span class="af_tbw_popup_button_text"  ><?php echo esc_attr( get_woocommerce_currency_symbol() ) . ' ' . esc_attr( $af_button_fixed_value ); ?></span>
									</label>
									<?php
								}
							}
							?>
						</div>
						<div class="adf_popup-other-field-percentage">
							<?php $af_td_other_field_place_holder = get_option('af_td_other_field_place_holder'); ?>
							<input type="number" value="<?php echo esc_attr( $custom_value ); ?>" class="af_tbw_fixed_amount" name="af_tbw_fixed_amount"  min="0" placeholder="<?php echo $af_td_other_field_place_holder ? esc_attr($af_td_other_field_place_holder):'Add amount'; ?>" >
						</div>
						<div class="af_tbw_other_options_percentage_popup" style="margin-top:15px">
							<button type="button" class="button alt af_tbw_popup_fixed" data-af-shortcode="yes"><?php echo esc_html( $af_tbw_tipping_or_donation_button_text ); ?></button>
							<button type="button" class="button alt af_tbw_removedata" style="display: none;"><?php echo esc_html__('Remove', 'addify-tipping-at-cart-checkout'); ?></button>
						</div>
					<?php
					} elseif ('percentage' === $af_tbw_tipping_or_donation_type) {
						?>
						<div class="adf-popup-pre-defined-value">
							<?php
							if ( $af_tbw_percentage_predefiend_values ) {
								$af_button_percentage_values = explode( ',', $af_tbw_percentage_predefiend_values );
								$af_button_percentage_values = array_unique( $af_button_percentage_values );
								foreach ( $af_button_percentage_values as $af_button_percentage_value ) {
									?>
									<label class="adf-popup-options">
										<input type="radio" class="af_tbw_popup_button"  <?php echo esc_attr( $af_button_percentage_value == $type ? 'checked' : '' ); ?> name="af_tbw_button_percentage_popup" value="<?php echo esc_attr( $af_button_percentage_value ); ?>" data-af_tbw_popup="<?php echo esc_attr( $af_button_percentage_value ); ?>" data-af-shortcode="yes">
										<span class="af_tbw_popup_button_text"  >
											<?php echo esc_attr( $af_button_percentage_value ); ?> %</span>
									</label>
										<?php
								}
							}
							?>
						</div>
						<div class="adf_popup-other-field-percentage">
							<?php $af_td_other_field_place_holder = get_option('af_td_other_field_place_holder'); ?>
							<input type="number" value="<?php echo esc_attr( $custom_value ); ?>" class="af_tbw_other_percentage" name="af_tbw_other_percentage"  min="0" placeholder="<?php echo $af_td_other_field_place_holder ? esc_attr($af_td_other_field_place_holder):'Add amount'; ?>" >
						</div>
						<div class="af_tbw_other_options_percentage_popup" style="margin-top:15px">
							<button type="button" class="button alt af_tbw_popup_percent" data-af-shortcode="yes" ><?php echo esc_html( $af_tbw_tipping_or_donation_button_text ); ?></button>
							<button type="button" class="button alt af_tbw_removedata"><?php echo esc_html__('Remove', 'addify-tipping-at-cart-checkout'); ?></button>
						</div>
					<?php
					}
					?>
				</div>
			</div>
		<?php
		return ob_get_clean();
	}
	
	/**
	 * Af_tbw_save_tipping_donation_in_reports_table.
	 *
	 * @param int $order_id Order ID.
	 */
	public function af_tbw_save_tipping_donation_in_reports_table( $order_id ) {

		if ( 0 !== ( WC()->session->get( 'af_tbw_tipping_donation_percentage_calculated' ) ) ) {

			$af_get_percentage_tipping_amount = WC()->session->get( 'af_tbw_tipping_donation_percentage_calculated' );
			$post_data                        = array(
				'post_type'   => 'donation_total',
				'post_status' => 'publish',
				'meta_input'  => array(
					'order_id'               => $order_id,
					'tipping_donation_total' => $af_get_percentage_tipping_amount,
				),
			);
			wp_insert_post( $post_data );
			$this->af_tbw_session_unset();

		}

		if ( 0 !== ( WC()->session->get( 'af_tbw_tipping_donation_fixed' ) ) ) {
			$af_get_fixed_tipping_amount = WC()->session->get( 'af_tbw_tipping_donation_fixed' );
			$post_data                   = array(
				'post_type'   => 'donation_total',
				'post_status' => 'publish',
				'meta_input'  => array(
					'order_id'               => $order_id,
					'tipping_donation_total' => $af_get_fixed_tipping_amount,
				),
			);
			wp_insert_post( $post_data );
			$this->af_tbw_session_unset();
		}
	}
	public function af_tbw_session_unset_empty_cart() {
		if (WC()->cart->is_empty()) {
		WC()->session->set( 'af_tbw_is_percent_calcultated', 0 );
		WC()->session->set( 'af_tbw_tipping_donation_percentage', 0 );
		WC()->session->set( 'af_tbw_tipping_donation_fixed', 0 );
		WC()->session->set( 'af_tbw_tipping_donation_percentage_calculated', 0 );
		}
	}
	/**
	 * Af_tbw_session_unset.
	 */
	public function af_tbw_session_unset() {

		WC()->session->set( 'af_tbw_is_percent_calcultated', 0 );
		WC()->session->set( 'af_tbw_tipping_donation_percentage', 0 );
		WC()->session->set( 'af_tbw_tipping_donation_fixed', 0 );
		WC()->session->set( 'af_tbw_tipping_donation_percentage_calculated', 0 );
	}
	/**
	 * Af_tbw_wp_tipping_enqueue_scripts.
	 */
	public function af_tbw_wp_tipping_enqueue_scripts() {
		$af_tbw_is_percent_calcultated = WC()->session->get( 'af_tbw_is_percent_calcultated' );
		wp_enqueue_style( 'af_tbw_css', AF_T_B_W_PLUGIN_URL . 'assets/css/front.css', array(), '1.0.0', 'all' );
		wp_enqueue_style( 'af_tbw_select2', AF_T_B_W_PLUGIN_URL . 'assets/css/select2.css', array(), '1.0.0', 'all' );
		wp_enqueue_script( 'af_tipping_donation', AF_T_B_W_PLUGIN_URL . 'assets/js/front.js', array( 'jquery' ), 4.0, true );
		wp_enqueue_script( 'af_tipping_select2', AF_T_B_W_PLUGIN_URL . 'assets/js/select2.js', array( 'jquery' ), 4.0, true );
		wp_localize_script(
			'af_tipping_donation',
			'af_tbw_ajax_obj',
			array(
				'ajax_url'                     => admin_url( 'admin-ajax.php' ),
				'nonce'                        => wp_create_nonce( 'af_tbw_nonce' ),
				'af_tbw_is_precent_calculated' => $af_tbw_is_percent_calcultated,
			)
		);
	}
}

new Af_Woo_Tipping_Or_Donation_Front();


